searchNodes=[{"ref":"GoogleApi.Spanner.V1.Api.Projects.html","title":"GoogleApi.Spanner.V1.Api.Projects","type":"module","doc":"API calls for all endpoints tagged Projects."},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_get/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_get/4","type":"function","doc":"Gets information about a particular instance configuration. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server name (type: String.t) - Required. The name of the requested instance configuration. Values are of the form projects/&lt;project&gt;/instanceConfigs/&lt;config&gt;. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.InstanceConfig{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_list/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_list/4","type":"function","doc":"Lists the supported instance configurations for a given project. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server parent (type: String.t) - Required. The name of the project for which a list of supported instance configurations is requested. Values are of the form projects/&lt;project&gt;. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :pageSize (type: integer()) - Number of instance configurations to be returned in the response. If 0 or less, defaults to the server&#39;s maximum allowed page size. :pageToken (type: String.t) - If non-empty, page_token should contain a next_page_token from a previous ListInstanceConfigsResponse. opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.ListInstanceConfigsResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_create/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_create/4","type":"function","doc":"Creates an instance and begins preparing it to begin serving. The returned long-running operation can be used to track the progress of preparing the new instance. The instance name is assigned by the caller. If the named instance already exists, CreateInstance returns ALREADY_EXISTS. Immediately upon completion of this request: The instance is readable via the API, with all requested attributes but no allocated resources. Its state is CREATING. Until completion of the returned operation: Cancelling the operation renders the instance immediately unreadable via the API. The instance can be deleted. All other attempts to modify the instance are rejected. Upon completion of the returned operation: Billing for all successfully-allocated resources begins (some types may have lower than the requested levels). Databases can be created in the instance. The instance&#39;s allocated resource levels are readable via the API. The instance&#39;s state becomes READY. The returned long-running operation will have a name of the format &lt;instance_name&gt;/operations/&lt;operation_id&gt; and can be used to track creation of the instance. The metadata field type is CreateInstanceMetadata. The response field type is Instance, if successful. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server parent (type: String.t) - Required. The name of the project in which to create the instance. Values are of the form projects/&lt;project&gt;. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.CreateInstanceRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Operation{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_create/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_create/4","type":"function","doc":"Creates a new Cloud Spanner database and starts to prepare it for serving. The returned long-running operation will have a name of the format &lt;database_name&gt;/operations/&lt;operation_id&gt; and can be used to track preparation of the database. The metadata field type is CreateDatabaseMetadata. The response field type is Database, if successful. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server parent (type: String.t) - Required. The name of the instance that will serve the new database. Values are of the form projects/&lt;project&gt;/instances/&lt;instance&gt;. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.CreateDatabaseRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Operation{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_drop_database/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_drop_database/4","type":"function","doc":"Drops (aka deletes) a Cloud Spanner database. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server database (type: String.t) - Required. The database to be dropped. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Empty{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_get/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_get/4","type":"function","doc":"Gets the state of a Cloud Spanner database. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server name (type: String.t) - Required. The name of the requested database. Values are of the form projects/&lt;project&gt;/instances/&lt;instance&gt;/databases/&lt;database&gt;. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Database{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_get_ddl/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_get_ddl/4","type":"function","doc":"Returns the schema of a Cloud Spanner database as a list of formatted DDL statements. This method does not show pending schema updates, those may be queried using the Operations API. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server database (type: String.t) - Required. The database whose schema we wish to get. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.GetDatabaseDdlResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_get_iam_policy/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_get_iam_policy/4","type":"function","doc":"Gets the access control policy for a database resource. Returns an empty policy if a database exists but does not have a policy set. Authorization requires spanner.databases.getIamPolicy permission on resource. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server resource (type: String.t) - REQUIRED: The Cloud Spanner resource for which the policy is being retrieved. The format is projects/&lt;project ID&gt;/instances/&lt;instance ID&gt; for instance resources and projects/&lt;project ID&gt;/instances/&lt;instance ID&gt;/databases/&lt;database ID&gt; for database resources. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.GetIamPolicyRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Policy{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_list/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_list/4","type":"function","doc":"Lists Cloud Spanner databases. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server parent (type: String.t) - Required. The instance whose databases should be listed. Values are of the form projects/&lt;project&gt;/instances/&lt;instance&gt;. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :pageSize (type: integer()) - Number of databases to be returned in the response. If 0 or less, defaults to the server&#39;s maximum allowed page size. :pageToken (type: String.t) - If non-empty, page_token should contain a next_page_token from a previous ListDatabasesResponse. opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.ListDatabasesResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_operations_cancel/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_operations_cancel/4","type":"function","doc":"Starts asynchronous cancellation on a long-running operation. The server makes a best effort to cancel the operation, but success is not guaranteed. If the server doesn&#39;t support this method, it returns google.rpc.Code.UNIMPLEMENTED. Clients can use Operations.GetOperation or other methods to check whether the cancellation succeeded or whether the operation completed despite cancellation. On successful cancellation, the operation is not deleted; instead, it becomes an operation with an Operation.error value with a google.rpc.Status.code of 1, corresponding to Code.CANCELLED. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server name (type: String.t) - The name of the operation resource to be cancelled. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Empty{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_operations_delete/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_operations_delete/4","type":"function","doc":"Deletes a long-running operation. This method indicates that the client is no longer interested in the operation result. It does not cancel the operation. If the server doesn&#39;t support this method, it returns google.rpc.Code.UNIMPLEMENTED. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server name (type: String.t) - The name of the operation resource to be deleted. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Empty{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_operations_get/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_operations_get/4","type":"function","doc":"Gets the latest state of a long-running operation. Clients can use this method to poll the operation result at intervals as recommended by the API service. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server name (type: String.t) - The name of the operation resource. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Operation{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_operations_list/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_operations_list/4","type":"function","doc":"Lists operations that match the specified filter in the request. If the server doesn&#39;t support this method, it returns UNIMPLEMENTED. NOTE: the name binding allows API services to override the binding to use different resource name schemes, such as users/*/operations. To override the binding, API services can add a binding such as &quot;/v1/{name=users/*}/operations&quot; to their service configuration. For backwards compatibility, the default name includes the operations collection id, however overriding users must ensure the name binding is the parent resource, without the operations collection id. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server name (type: String.t) - The name of the operation&#39;s parent resource. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :filter (type: String.t) - The standard list filter. :pageSize (type: integer()) - The standard list page size. :pageToken (type: String.t) - The standard list page token. opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.ListOperationsResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_begin_transaction/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_begin_transaction/4","type":"function","doc":"Begins a new transaction. This step can often be skipped: Read, ExecuteSql and Commit can begin a new transaction as a side-effect. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server session (type: String.t) - Required. The session in which the transaction runs. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.BeginTransactionRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Transaction{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_commit/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_commit/4","type":"function","doc":"Commits a transaction. The request includes the mutations to be applied to rows in the database. Commit might return an ABORTED error. This can occur at any time; commonly, the cause is conflicts with concurrent transactions. However, it can also happen for a variety of other reasons. If Commit returns ABORTED, the caller should re-attempt the transaction from the beginning, re-using the same session. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server session (type: String.t) - Required. The session in which the transaction to be committed is running. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.CommitRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.CommitResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_create/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_create/4","type":"function","doc":"Creates a new session. A session can be used to perform transactions that read and/or modify data in a Cloud Spanner database. Sessions are meant to be reused for many consecutive transactions. Sessions can only execute one transaction at a time. To execute multiple concurrent read-write/write-only transactions, create multiple sessions. Note that standalone reads and queries use a transaction internally, and count toward the one transaction limit. Cloud Spanner limits the number of sessions that can exist at any given time; thus, it is a good idea to delete idle and/or unneeded sessions. Aside from explicit deletes, Cloud Spanner can delete sessions for which no operations are sent for more than an hour. If a session is deleted, requests to it return NOT_FOUND. Idle sessions can be kept alive by sending a trivial SQL query periodically, e.g., &quot;SELECT 1&quot;. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server database (type: String.t) - Required. The database in which the new session is created. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.CreateSessionRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Session{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_delete/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_delete/4","type":"function","doc":"Ends a session, releasing server resources associated with it. This will asynchronously trigger cancellation of any operations that are running with this session. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server name (type: String.t) - Required. The name of the session to delete. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Empty{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_execute_batch_dml/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_execute_batch_dml/4","type":"function","doc":"Executes a batch of SQL DML statements. This method allows many statements to be run with lower latency than submitting them sequentially with ExecuteSql. Statements are executed in order, sequentially. ExecuteBatchDmlResponse will contain a ResultSet for each DML statement that has successfully executed. If a statement fails, its error status will be returned as part of the ExecuteBatchDmlResponse. Execution will stop at the first failed statement; the remaining statements will not run. ExecuteBatchDml is expected to return an OK status with a response even if there was an error while processing one of the DML statements. Clients must inspect response.status to determine if there were any errors while processing the request. See more details in ExecuteBatchDmlRequest and ExecuteBatchDmlResponse. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server session (type: String.t) - Required. The session in which the DML statements should be performed. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.ExecuteBatchDmlRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.ExecuteBatchDmlResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_execute_sql/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_execute_sql/4","type":"function","doc":"Executes an SQL statement, returning all results in a single reply. This method cannot be used to return a result set larger than 10 MiB; if the query yields more data than that, the query fails with a FAILED_PRECONDITION error. Operations inside read-write transactions might return ABORTED. If this occurs, the application should restart the transaction from the beginning. See Transaction for more details. Larger result sets can be fetched in streaming fashion by calling ExecuteStreamingSql instead. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server session (type: String.t) - Required. The session in which the SQL query should be performed. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.ExecuteSqlRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.ResultSet{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_execute_streaming_sql/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_execute_streaming_sql/4","type":"function","doc":"Like ExecuteSql, except returns the result set as a stream. Unlike ExecuteSql, there is no limit on the size of the returned result set. However, no individual row in the result set can exceed 100 MiB, and no column value can exceed 10 MiB. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server session (type: String.t) - Required. The session in which the SQL query should be performed. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.ExecuteSqlRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.PartialResultSet{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_get/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_get/4","type":"function","doc":"Gets a session. Returns NOT_FOUND if the session does not exist. This is mainly useful for determining whether a session is still alive. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server name (type: String.t) - Required. The name of the session to retrieve. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Session{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_list/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_list/4","type":"function","doc":"Lists all sessions in a given database. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server database (type: String.t) - Required. The database in which to list sessions. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :filter (type: String.t) - An expression for filtering the results of the request. Filter rules are case insensitive. The fields eligible for filtering are: labels.key where key is the name of a label Some examples of using filters are: labels.env:* --&gt; The session has the label &quot;env&quot;. labels.env:dev --&gt; The session has the label &quot;env&quot; and the value of the label contains the string &quot;dev&quot;. :pageSize (type: integer()) - Number of sessions to be returned in the response. If 0 or less, defaults to the server&#39;s maximum allowed page size. :pageToken (type: String.t) - If non-empty, page_token should contain a next_page_token from a previous ListSessionsResponse. opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.ListSessionsResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_partition_query/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_partition_query/4","type":"function","doc":"Creates a set of partition tokens that can be used to execute a query operation in parallel. Each of the returned partition tokens can be used by ExecuteStreamingSql to specify a subset of the query result to read. The same session and read-only transaction must be used by the PartitionQueryRequest used to create the partition tokens and the ExecuteSqlRequests that use the partition tokens. Partition tokens become invalid when the session used to create them is deleted, is idle for too long, begins a new transaction, or becomes too old. When any of these happen, it is not possible to resume the query, and the whole operation must be restarted from the beginning. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server session (type: String.t) - Required. The session used to create the partitions. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.PartitionQueryRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.PartitionResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_partition_read/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_partition_read/4","type":"function","doc":"Creates a set of partition tokens that can be used to execute a read operation in parallel. Each of the returned partition tokens can be used by StreamingRead to specify a subset of the read result to read. The same session and read-only transaction must be used by the PartitionReadRequest used to create the partition tokens and the ReadRequests that use the partition tokens. There are no ordering guarantees on rows returned among the returned partition tokens, or even within each individual StreamingRead call issued with a partition_token. Partition tokens become invalid when the session used to create them is deleted, is idle for too long, begins a new transaction, or becomes too old. When any of these happen, it is not possible to resume the read, and the whole operation must be restarted from the beginning. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server session (type: String.t) - Required. The session used to create the partitions. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.PartitionReadRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.PartitionResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_read/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_read/4","type":"function","doc":"Reads rows from the database using key lookups and scans, as a simple key/value style alternative to ExecuteSql. This method cannot be used to return a result set larger than 10 MiB; if the read matches more data than that, the read fails with a FAILED_PRECONDITION error. Reads inside read-write transactions might return ABORTED. If this occurs, the application should restart the transaction from the beginning. See Transaction for more details. Larger result sets can be yielded in streaming fashion by calling StreamingRead instead. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server session (type: String.t) - Required. The session in which the read should be performed. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.ReadRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.ResultSet{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_rollback/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_rollback/4","type":"function","doc":"Rolls back a transaction, releasing any locks it holds. It is a good idea to call this for any transaction that includes one or more Read or ExecuteSql requests and ultimately decides not to commit. Rollback returns OK if it successfully aborts the transaction, the transaction was already aborted, or the transaction is not found. Rollback never returns ABORTED. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server session (type: String.t) - Required. The session in which the transaction to roll back is running. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.RollbackRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Empty{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_streaming_read/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_streaming_read/4","type":"function","doc":"Like Read, except returns the result set as a stream. Unlike Read, there is no limit on the size of the returned result set. However, no individual row in the result set can exceed 100 MiB, and no column value can exceed 10 MiB. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server session (type: String.t) - Required. The session in which the read should be performed. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.ReadRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.PartialResultSet{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_set_iam_policy/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_set_iam_policy/4","type":"function","doc":"Sets the access control policy on a database resource. Replaces any existing policy. Authorization requires spanner.databases.setIamPolicy permission on resource. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server resource (type: String.t) - REQUIRED: The Cloud Spanner resource for which the policy is being set. The format is projects/&lt;project ID&gt;/instances/&lt;instance ID&gt; for instance resources and projects/&lt;project ID&gt;/instances/&lt;instance ID&gt;/databases/&lt;database ID&gt; for databases resources. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.SetIamPolicyRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Policy{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_test_iam_permissions/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_test_iam_permissions/4","type":"function","doc":"Returns permissions that the caller has on the specified database resource. Attempting this RPC on a non-existent Cloud Spanner database will result in a NOT_FOUND error if the user has spanner.databases.list permission on the containing Cloud Spanner instance. Otherwise returns an empty set of permissions. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server resource (type: String.t) - REQUIRED: The Cloud Spanner resource for which permissions are being tested. The format is projects/&lt;project ID&gt;/instances/&lt;instance ID&gt; for instance resources and projects/&lt;project ID&gt;/instances/&lt;instance ID&gt;/databases/&lt;database ID&gt; for database resources. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_update_ddl/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_update_ddl/4","type":"function","doc":"Updates the schema of a Cloud Spanner database by creating/altering/dropping tables, columns, indexes, etc. The returned long-running operation will have a name of the format &lt;database_name&gt;/operations/&lt;operation_id&gt; and can be used to track execution of the schema change(s). The metadata field type is UpdateDatabaseDdlMetadata. The operation has no response. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server database (type: String.t) - Required. The database to update. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Operation{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_delete/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_delete/4","type":"function","doc":"Deletes an instance. Immediately upon completion of the request: Billing ceases for all of the instance&#39;s reserved resources. Soon afterward: The instance and all of its databases immediately and irrevocably disappear from the API. All data in the databases is permanently deleted. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server name (type: String.t) - Required. The name of the instance to be deleted. Values are of the form projects/&lt;project&gt;/instances/&lt;instance&gt; optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Empty{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_get/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_get/4","type":"function","doc":"Gets information about a particular instance. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server name (type: String.t) - Required. The name of the requested instance. Values are of the form projects/&lt;project&gt;/instances/&lt;instance&gt;. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Instance{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_get_iam_policy/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_get_iam_policy/4","type":"function","doc":"Gets the access control policy for an instance resource. Returns an empty policy if an instance exists but does not have a policy set. Authorization requires spanner.instances.getIamPolicy on resource. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server resource (type: String.t) - REQUIRED: The Cloud Spanner resource for which the policy is being retrieved. The format is projects/&lt;project ID&gt;/instances/&lt;instance ID&gt; for instance resources and projects/&lt;project ID&gt;/instances/&lt;instance ID&gt;/databases/&lt;database ID&gt; for database resources. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.GetIamPolicyRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Policy{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_list/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_list/4","type":"function","doc":"Lists all instances in the given project. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server parent (type: String.t) - Required. The name of the project for which a list of instances is requested. Values are of the form projects/&lt;project&gt;. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :filter (type: String.t) - An expression for filtering the results of the request. Filter rules are case insensitive. The fields eligible for filtering are: name display_name labels.key where key is the name of a label Some examples of using filters are: name:* --&gt; The instance has a name. name:Howl --&gt; The instance&#39;s name contains the string &quot;howl&quot;. name:HOWL --&gt; Equivalent to above. NAME:howl --&gt; Equivalent to above. labels.env:* --&gt; The instance has the label &quot;env&quot;. labels.env:dev --&gt; The instance has the label &quot;env&quot; and the value of the label contains the string &quot;dev&quot;. name:howl labels.env:dev --&gt; The instance&#39;s name contains &quot;howl&quot; and it has the label &quot;env&quot; with its value containing &quot;dev&quot;. :pageSize (type: integer()) - Number of instances to be returned in the response. If 0 or less, defaults to the server&#39;s maximum allowed page size. :pageToken (type: String.t) - If non-empty, page_token should contain a next_page_token from a previous ListInstancesResponse. opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.ListInstancesResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_operations_cancel/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_operations_cancel/4","type":"function","doc":"Starts asynchronous cancellation on a long-running operation. The server makes a best effort to cancel the operation, but success is not guaranteed. If the server doesn&#39;t support this method, it returns google.rpc.Code.UNIMPLEMENTED. Clients can use Operations.GetOperation or other methods to check whether the cancellation succeeded or whether the operation completed despite cancellation. On successful cancellation, the operation is not deleted; instead, it becomes an operation with an Operation.error value with a google.rpc.Status.code of 1, corresponding to Code.CANCELLED. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server name (type: String.t) - The name of the operation resource to be cancelled. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Empty{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_operations_delete/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_operations_delete/4","type":"function","doc":"Deletes a long-running operation. This method indicates that the client is no longer interested in the operation result. It does not cancel the operation. If the server doesn&#39;t support this method, it returns google.rpc.Code.UNIMPLEMENTED. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server name (type: String.t) - The name of the operation resource to be deleted. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Empty{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_operations_get/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_operations_get/4","type":"function","doc":"Gets the latest state of a long-running operation. Clients can use this method to poll the operation result at intervals as recommended by the API service. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server name (type: String.t) - The name of the operation resource. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Operation{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_operations_list/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_operations_list/4","type":"function","doc":"Lists operations that match the specified filter in the request. If the server doesn&#39;t support this method, it returns UNIMPLEMENTED. NOTE: the name binding allows API services to override the binding to use different resource name schemes, such as users/*/operations. To override the binding, API services can add a binding such as &quot;/v1/{name=users/*}/operations&quot; to their service configuration. For backwards compatibility, the default name includes the operations collection id, however overriding users must ensure the name binding is the parent resource, without the operations collection id. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server name (type: String.t) - The name of the operation&#39;s parent resource. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :filter (type: String.t) - The standard list filter. :pageSize (type: integer()) - The standard list page size. :pageToken (type: String.t) - The standard list page token. opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.ListOperationsResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_patch/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_patch/4","type":"function","doc":"Updates an instance, and begins allocating or releasing resources as requested. The returned long-running operation can be used to track the progress of updating the instance. If the named instance does not exist, returns NOT_FOUND. Immediately upon completion of this request: For resource types for which a decrease in the instance&#39;s allocation has been requested, billing is based on the newly-requested level. Until completion of the returned operation: Cancelling the operation sets its metadata&#39;s cancel_time, and begins restoring resources to their pre-request values. The operation is guaranteed to succeed at undoing all resource changes, after which point it terminates with a CANCELLED status. All other attempts to modify the instance are rejected. Reading the instance via the API continues to give the pre-request resource levels. Upon completion of the returned operation: Billing begins for all successfully-allocated resources (some types may have lower than the requested levels). All newly-reserved resources are available for serving the instance&#39;s tables. The instance&#39;s new resource levels are readable via the API. The returned long-running operation will have a name of the format &lt;instance_name&gt;/operations/&lt;operation_id&gt; and can be used to track the instance modification. The metadata field type is UpdateInstanceMetadata. The response field type is Instance, if successful. Authorization requires spanner.instances.update permission on resource name. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server name (type: String.t) - Required. A unique identifier for the instance, which cannot be changed after the instance is created. Values are of the form projects/&lt;project&gt;/instances/a-z*[a-z0-9]. The final segment of the name must be between 2 and 64 characters in length. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.UpdateInstanceRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Operation{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_set_iam_policy/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_set_iam_policy/4","type":"function","doc":"Sets the access control policy on an instance resource. Replaces any existing policy. Authorization requires spanner.instances.setIamPolicy on resource. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server resource (type: String.t) - REQUIRED: The Cloud Spanner resource for which the policy is being set. The format is projects/&lt;project ID&gt;/instances/&lt;instance ID&gt; for instance resources and projects/&lt;project ID&gt;/instances/&lt;instance ID&gt;/databases/&lt;database ID&gt; for databases resources. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.SetIamPolicyRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.Policy{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_test_iam_permissions/4","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_test_iam_permissions/4","type":"function","doc":"Returns permissions that the caller has on the specified instance resource. Attempting this RPC on a non-existent Cloud Spanner instance resource will result in a NOT_FOUND error if the user has spanner.instances.list permission on the containing Google Cloud Project. Otherwise returns an empty set of permissions. Parameters connection (type: GoogleApi.Spanner.V1.Connection.t) - Connection to server resource (type: String.t) - REQUIRED: The Cloud Spanner resource for which permissions are being tested. The format is projects/&lt;project ID&gt;/instances/&lt;instance ID&gt; for instance resources and projects/&lt;project ID&gt;/instances/&lt;instance ID&gt;/databases/&lt;database ID&gt; for database resources. optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.Spanner.V1.Connection.html","title":"GoogleApi.Spanner.V1.Connection","type":"module","doc":"Handle Tesla connections for GoogleApi.Spanner.V1."},{"ref":"GoogleApi.Spanner.V1.Connection.html#delete/3","title":"GoogleApi.Spanner.V1.Connection.delete/3","type":"function","doc":"Perform a DELETE request. See request/1 or request/2 for options definition. delete(&quot;/users&quot;) delete(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) delete(client, &quot;/users&quot;) delete(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.Spanner.V1.Connection.html#delete!/3","title":"GoogleApi.Spanner.V1.Connection.delete!/3","type":"function","doc":"Perform a DELETE request. See request!/1 or request!/2 for options definition. delete!(&quot;/users&quot;) delete!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) delete!(client, &quot;/users&quot;) delete!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.Spanner.V1.Connection.html#execute/2","title":"GoogleApi.Spanner.V1.Connection.execute/2","type":"function","doc":"Execute a request on this connection Returns Tesla.Env"},{"ref":"GoogleApi.Spanner.V1.Connection.html#get/3","title":"GoogleApi.Spanner.V1.Connection.get/3","type":"function","doc":"Perform a GET request. See request/1 or request/2 for options definition. get(&quot;/users&quot;) get(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) get(client, &quot;/users&quot;) get(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.Spanner.V1.Connection.html#get!/3","title":"GoogleApi.Spanner.V1.Connection.get!/3","type":"function","doc":"Perform a GET request. See request!/1 or request!/2 for options definition. get!(&quot;/users&quot;) get!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) get!(client, &quot;/users&quot;) get!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.Spanner.V1.Connection.html#head/3","title":"GoogleApi.Spanner.V1.Connection.head/3","type":"function","doc":"Perform a HEAD request. See request/1 or request/2 for options definition. head(&quot;/users&quot;) head(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) head(client, &quot;/users&quot;) head(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.Spanner.V1.Connection.html#head!/3","title":"GoogleApi.Spanner.V1.Connection.head!/3","type":"function","doc":"Perform a HEAD request. See request!/1 or request!/2 for options definition. head!(&quot;/users&quot;) head!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) head!(client, &quot;/users&quot;) head!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.Spanner.V1.Connection.html#new/0","title":"GoogleApi.Spanner.V1.Connection.new/0","type":"function","doc":"Configure an authless client connection Returns Tesla.Client.t"},{"ref":"GoogleApi.Spanner.V1.Connection.html#new/1","title":"GoogleApi.Spanner.V1.Connection.new/1","type":"function","doc":"Configure a client connection using a function which yields a Bearer token. Parameters token_fetcher (function arity of 1): Callback which provides an OAuth2 token given a list of scopes Returns Tesla.Env.client"},{"ref":"GoogleApi.Spanner.V1.Connection.html#options/3","title":"GoogleApi.Spanner.V1.Connection.options/3","type":"function","doc":"Perform a OPTIONS request. See request/1 or request/2 for options definition. options(&quot;/users&quot;) options(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) options(client, &quot;/users&quot;) options(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.Spanner.V1.Connection.html#options!/3","title":"GoogleApi.Spanner.V1.Connection.options!/3","type":"function","doc":"Perform a OPTIONS request. See request!/1 or request!/2 for options definition. options!(&quot;/users&quot;) options!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) options!(client, &quot;/users&quot;) options!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.Spanner.V1.Connection.html#patch/4","title":"GoogleApi.Spanner.V1.Connection.patch/4","type":"function","doc":"Perform a PATCH request. See request/1 or request/2 for options definition. patch(&quot;/users&quot;, %{name: &quot;Jon&quot;}) patch(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) patch(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) patch(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.Spanner.V1.Connection.html#patch!/4","title":"GoogleApi.Spanner.V1.Connection.patch!/4","type":"function","doc":"Perform a PATCH request. See request!/1 or request!/2 for options definition. patch!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) patch!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) patch!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) patch!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.Spanner.V1.Connection.html#post/4","title":"GoogleApi.Spanner.V1.Connection.post/4","type":"function","doc":"Perform a POST request. See request/1 or request/2 for options definition. post(&quot;/users&quot;, %{name: &quot;Jon&quot;}) post(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.Spanner.V1.Connection.html#post!/4","title":"GoogleApi.Spanner.V1.Connection.post!/4","type":"function","doc":"Perform a POST request. See request!/1 or request!/2 for options definition. post!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) post!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) post!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) post!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.Spanner.V1.Connection.html#put/4","title":"GoogleApi.Spanner.V1.Connection.put/4","type":"function","doc":"Perform a PUT request. See request/1 or request/2 for options definition. put(&quot;/users&quot;, %{name: &quot;Jon&quot;}) put(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) put(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) put(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.Spanner.V1.Connection.html#put!/4","title":"GoogleApi.Spanner.V1.Connection.put!/4","type":"function","doc":"Perform a PUT request. See request!/1 or request!/2 for options definition. put!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) put!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) put!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) put!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.Spanner.V1.Connection.html#request/2","title":"GoogleApi.Spanner.V1.Connection.request/2","type":"function","doc":"Perform a request Options: :method - the request method, one of [:head, :get, :delete, :trace, :options, :post, :put, :patch] :url - either full url e.g. &quot;http://example.com/some/path&quot; or just &quot;/some/path&quot; if using Tesla.Middleware.BaseUrl :query - a keyword list of query params, e.g. [page: 1, per_page: 100] :headers - a keyworld list of headers, e.g. [{&quot;content-type&quot;, &quot;text/plain&quot;}] :body - depends on used middleware: by default it can be a binary if using e.g. JSON encoding middleware it can be a nested map if adapter supports it it can be a Stream with any of the above :opts - custom, per-request middleware or adapter options Examples: ExampleApi.request(method: :get, url: &quot;/users/path&quot;) You can also use shortcut methods like: ExampleApi.get(&quot;/users/1&quot;) or ExampleApi.post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;})"},{"ref":"GoogleApi.Spanner.V1.Connection.html#request!/2","title":"GoogleApi.Spanner.V1.Connection.request!/2","type":"function","doc":"Perform request and raise in case of error. This is similar to request/2 behaviour from Tesla 0.x See request/2 for list of available options."},{"ref":"GoogleApi.Spanner.V1.Connection.html#trace/3","title":"GoogleApi.Spanner.V1.Connection.trace/3","type":"function","doc":"Perform a TRACE request. See request/1 or request/2 for options definition. trace(&quot;/users&quot;) trace(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) trace(client, &quot;/users&quot;) trace(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.Spanner.V1.Connection.html#trace!/3","title":"GoogleApi.Spanner.V1.Connection.trace!/3","type":"function","doc":"Perform a TRACE request. See request!/1 or request!/2 for options definition. trace!(&quot;/users&quot;) trace!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) trace!(client, &quot;/users&quot;) trace!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.Spanner.V1.Connection.html#t:option/0","title":"GoogleApi.Spanner.V1.Connection.option/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Connection.html#t:t/0","title":"GoogleApi.Spanner.V1.Connection.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.BeginTransactionRequest.html","title":"GoogleApi.Spanner.V1.Model.BeginTransactionRequest","type":"module","doc":"The request for BeginTransaction. Attributes options (type: GoogleApi.Spanner.V1.Model.TransactionOptions.t, default: nil) - Required. Options for the new transaction."},{"ref":"GoogleApi.Spanner.V1.Model.BeginTransactionRequest.html#decode/2","title":"GoogleApi.Spanner.V1.Model.BeginTransactionRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.BeginTransactionRequest.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.BeginTransactionRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.Binding.html","title":"GoogleApi.Spanner.V1.Model.Binding","type":"module","doc":"Associates members with a role. Attributes condition (type: GoogleApi.Spanner.V1.Model.Expr.t, default: nil) - The condition that is associated with this binding. NOTE: An unsatisfied condition will not allow user access via current binding. Different bindings, including their conditions, are examined independently. members (type: list(String.t), default: nil) - Specifies the identities requesting access for a Cloud Platform resource. members can have the following values: allUsers: A special identifier that represents anyone who is on the internet; with or without a Google account. allAuthenticatedUsers: A special identifier that represents anyone who is authenticated with a Google account or a service account. user:{emailid}: An email address that represents a specific Google account. For example, alice@gmail.com . serviceAccount:{emailid}: An email address that represents a service account. For example, my-other-app@appspot.gserviceaccount.com. group:{emailid}: An email address that represents a Google group. For example, admins@example.com. domain:{domain}: The G Suite domain (primary) that represents all the users of that domain. For example, google.com or example.com. role (type: String.t, default: nil) - Role that is assigned to members. For example, roles/viewer, roles/editor, or roles/owner."},{"ref":"GoogleApi.Spanner.V1.Model.Binding.html#decode/2","title":"GoogleApi.Spanner.V1.Model.Binding.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.Binding.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.Binding.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.ChildLink.html","title":"GoogleApi.Spanner.V1.Model.ChildLink","type":"module","doc":"Metadata associated with a parent-child relationship appearing in a PlanNode. Attributes childIndex (type: integer(), default: nil) - The node to which the link points. type (type: String.t, default: nil) - The type of the link. For example, in Hash Joins this could be used to distinguish between the build child and the probe child, or in the case of the child being an output variable, to represent the tag associated with the output variable. variable (type: String.t, default: nil) - Only present if the child node is SCALAR and corresponds to an output variable of the parent node. The field carries the name of the output variable. For example, a TableScan operator that reads rows from a table will have child links to the SCALAR nodes representing the output variables created for each column that is read by the operator. The corresponding variable fields will be set to the variable names assigned to the columns."},{"ref":"GoogleApi.Spanner.V1.Model.ChildLink.html#decode/2","title":"GoogleApi.Spanner.V1.Model.ChildLink.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.ChildLink.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.ChildLink.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.CommitRequest.html","title":"GoogleApi.Spanner.V1.Model.CommitRequest","type":"module","doc":"The request for Commit. Attributes mutations (type: list(GoogleApi.Spanner.V1.Model.Mutation.t), default: nil) - The mutations to be executed when this transaction commits. All mutations are applied atomically, in the order they appear in this list. singleUseTransaction (type: GoogleApi.Spanner.V1.Model.TransactionOptions.t, default: nil) - Execute mutations in a temporary transaction. Note that unlike commit of a previously-started transaction, commit with a temporary transaction is non-idempotent. That is, if the CommitRequest is sent to Cloud Spanner more than once (for instance, due to retries in the application, or in the transport library), it is possible that the mutations are executed more than once. If this is undesirable, use BeginTransaction and Commit instead. transactionId (type: String.t, default: nil) - Commit a previously-started transaction."},{"ref":"GoogleApi.Spanner.V1.Model.CommitRequest.html#decode/2","title":"GoogleApi.Spanner.V1.Model.CommitRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.CommitRequest.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.CommitRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.CommitResponse.html","title":"GoogleApi.Spanner.V1.Model.CommitResponse","type":"module","doc":"The response for Commit. Attributes commitTimestamp (type: DateTime.t, default: nil) - The Cloud Spanner timestamp at which the transaction committed."},{"ref":"GoogleApi.Spanner.V1.Model.CommitResponse.html#decode/2","title":"GoogleApi.Spanner.V1.Model.CommitResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.CommitResponse.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.CommitResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.CreateDatabaseMetadata.html","title":"GoogleApi.Spanner.V1.Model.CreateDatabaseMetadata","type":"module","doc":"Metadata type for the operation returned by CreateDatabase. Attributes database (type: String.t, default: nil) - The database being created."},{"ref":"GoogleApi.Spanner.V1.Model.CreateDatabaseMetadata.html#decode/2","title":"GoogleApi.Spanner.V1.Model.CreateDatabaseMetadata.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.CreateDatabaseMetadata.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.CreateDatabaseMetadata.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.CreateDatabaseRequest.html","title":"GoogleApi.Spanner.V1.Model.CreateDatabaseRequest","type":"module","doc":"The request for CreateDatabase. Attributes createStatement (type: String.t, default: nil) - Required. A CREATE DATABASE statement, which specifies the ID of the new database. The database ID must conform to the regular expression a-z*[a-z0-9] and be between 2 and 30 characters in length. If the database ID is a reserved word or if it contains a hyphen, the database ID must be enclosed in backticks (`). extraStatements (type: list(String.t), default: nil) - An optional list of DDL statements to run inside the newly created database. Statements can create tables, indexes, etc. These statements execute atomically with the creation of the database: if there is an error in any statement, the database is not created."},{"ref":"GoogleApi.Spanner.V1.Model.CreateDatabaseRequest.html#decode/2","title":"GoogleApi.Spanner.V1.Model.CreateDatabaseRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.CreateDatabaseRequest.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.CreateDatabaseRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.CreateInstanceMetadata.html","title":"GoogleApi.Spanner.V1.Model.CreateInstanceMetadata","type":"module","doc":"Metadata type for the operation returned by CreateInstance. Attributes cancelTime (type: DateTime.t, default: nil) - The time at which this operation was cancelled. If set, this operation is in the process of undoing itself (which is guaranteed to succeed) and cannot be cancelled again. endTime (type: DateTime.t, default: nil) - The time at which this operation failed or was completed successfully. instance (type: GoogleApi.Spanner.V1.Model.Instance.t, default: nil) - The instance being created. startTime (type: DateTime.t, default: nil) - The time at which the CreateInstance request was received."},{"ref":"GoogleApi.Spanner.V1.Model.CreateInstanceMetadata.html#decode/2","title":"GoogleApi.Spanner.V1.Model.CreateInstanceMetadata.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.CreateInstanceMetadata.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.CreateInstanceMetadata.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.CreateInstanceRequest.html","title":"GoogleApi.Spanner.V1.Model.CreateInstanceRequest","type":"module","doc":"The request for CreateInstance. Attributes instance (type: GoogleApi.Spanner.V1.Model.Instance.t, default: nil) - Required. The instance to create. The name may be omitted, but if specified must be &lt;parent&gt;/instances/&lt;instance_id&gt;. instanceId (type: String.t, default: nil) - Required. The ID of the instance to create. Valid identifiers are of the form a-z*[a-z0-9] and must be between 2 and 64 characters in length."},{"ref":"GoogleApi.Spanner.V1.Model.CreateInstanceRequest.html#decode/2","title":"GoogleApi.Spanner.V1.Model.CreateInstanceRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.CreateInstanceRequest.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.CreateInstanceRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.CreateSessionRequest.html","title":"GoogleApi.Spanner.V1.Model.CreateSessionRequest","type":"module","doc":"The request for CreateSession. Attributes session (type: GoogleApi.Spanner.V1.Model.Session.t, default: nil) - The session to create."},{"ref":"GoogleApi.Spanner.V1.Model.CreateSessionRequest.html#decode/2","title":"GoogleApi.Spanner.V1.Model.CreateSessionRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.CreateSessionRequest.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.CreateSessionRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.Database.html","title":"GoogleApi.Spanner.V1.Model.Database","type":"module","doc":"A Cloud Spanner database. Attributes name (type: String.t, default: nil) - Required. The name of the database. Values are of the form projects/&lt;project&gt;/instances/&lt;instance&gt;/databases/&lt;database&gt;, where &lt;database&gt; is as specified in the CREATE DATABASE statement. This name can be passed to other API methods to identify the database. state (type: String.t, default: nil) - Output only. The current database state."},{"ref":"GoogleApi.Spanner.V1.Model.Database.html#decode/2","title":"GoogleApi.Spanner.V1.Model.Database.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.Database.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.Database.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.Delete.html","title":"GoogleApi.Spanner.V1.Model.Delete","type":"module","doc":"Arguments to delete operations. Attributes keySet (type: GoogleApi.Spanner.V1.Model.KeySet.t, default: nil) - Required. The primary keys of the rows within table to delete. Delete is idempotent. The transaction will succeed even if some or all rows do not exist. table (type: String.t, default: nil) - Required. The table whose rows will be deleted."},{"ref":"GoogleApi.Spanner.V1.Model.Delete.html#decode/2","title":"GoogleApi.Spanner.V1.Model.Delete.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.Delete.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.Delete.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.Empty.html","title":"GoogleApi.Spanner.V1.Model.Empty","type":"module","doc":"A generic empty message that you can re-use to avoid defining duplicated empty messages in your APIs. A typical example is to use it as the request or the response type of an API method. For instance: service Foo { rpc Bar(google.protobuf.Empty) returns (google.protobuf.Empty); } The JSON representation for Empty is empty JSON object {}. Attributes"},{"ref":"GoogleApi.Spanner.V1.Model.Empty.html#decode/2","title":"GoogleApi.Spanner.V1.Model.Empty.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.Empty.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.Empty.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlRequest.html","title":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlRequest","type":"module","doc":"The request for ExecuteBatchDml Attributes seqno (type: String.t, default: nil) - A per-transaction sequence number used to identify this request. This is used in the same space as the seqno in ExecuteSqlRequest. See more details in ExecuteSqlRequest. statements (type: list(GoogleApi.Spanner.V1.Model.Statement.t), default: nil) - The list of statements to execute in this batch. Statements are executed serially, such that the effects of statement i are visible to statement i+1. Each statement must be a DML statement. Execution will stop at the first failed statement; the remaining statements will not run. REQUIRES: statements_size() &gt; 0. transaction (type: GoogleApi.Spanner.V1.Model.TransactionSelector.t, default: nil) - The transaction to use. A ReadWrite transaction is required. Single-use transactions are not supported (to avoid replay). The caller must either supply an existing transaction ID or begin a new transaction."},{"ref":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlRequest.html#decode/2","title":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlRequest.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlResponse.html","title":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlResponse","type":"module","doc":"The response for ExecuteBatchDml. Contains a list of ResultSet, one for each DML statement that has successfully executed. If a statement fails, the error is returned as part of the response payload. Clients can determine whether all DML statements have run successfully, or if a statement failed, using one of the following approaches: Check if &#39;status&#39; field is OkStatus. Check if result_sets_size() equals the number of statements in ExecuteBatchDmlRequest. Example 1: A request with 5 DML statements, all executed successfully. Result: A response with 5 ResultSets, one for each statement in the same order, and an OkStatus. Example 2: A request with 5 DML statements. The 3rd statement has a syntax error. Result: A response with 2 ResultSets, for the first 2 statements that run successfully, and a syntax error (INVALID_ARGUMENT) status. From result_set_size() client can determine that the 3rd statement has failed. Attributes resultSets (type: list(GoogleApi.Spanner.V1.Model.ResultSet.t), default: nil) - ResultSets, one for each statement in the request that ran successfully, in the same order as the statements in the request. Each ResultSet will not contain any rows. The ResultSetStats in each ResultSet will contain the number of rows modified by the statement. Only the first ResultSet in the response contains a valid ResultSetMetadata. status (type: GoogleApi.Spanner.V1.Model.Status.t, default: nil) - If all DML statements are executed successfully, status will be OK. Otherwise, the error status of the first failed statement."},{"ref":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlResponse.html#decode/2","title":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlResponse.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.ExecuteSqlRequest.html","title":"GoogleApi.Spanner.V1.Model.ExecuteSqlRequest","type":"module","doc":"The request for ExecuteSql and ExecuteStreamingSql. Attributes paramTypes (type: %{optional(String.t) =&gt; GoogleApi.Spanner.V1.Model.Type.t}, default: nil) - It is not always possible for Cloud Spanner to infer the right SQL type from a JSON value. For example, values of type BYTES and values of type STRING both appear in params as JSON strings. In these cases, param_types can be used to specify the exact SQL type for some or all of the SQL statement parameters. See the definition of Type for more information about SQL types. params (type: map(), default: nil) - The SQL string can contain parameter placeholders. A parameter placeholder consists of &#39;@&#39; followed by the parameter name. Parameter names consist of any combination of letters, numbers, and underscores. Parameters can appear anywhere that a literal value is expected. The same parameter name can be used more than once, for example: &quot;WHERE id &gt; @msg_id AND id &lt; @msg_id + 100&quot; It is an error to execute an SQL statement with unbound parameters. Parameter values are specified using params, which is a JSON object whose keys are parameter names, and whose values are the corresponding parameter values. partitionToken (type: String.t, default: nil) - If present, results will be restricted to the specified partition previously created using PartitionQuery(). There must be an exact match for the values of fields common to this message and the PartitionQueryRequest message used to create this partition_token. queryMode (type: String.t, default: nil) - Used to control the amount of debugging information returned in ResultSetStats. If partition_token is set, query_mode can only be set to QueryMode.NORMAL. resumeToken (type: String.t, default: nil) - If this request is resuming a previously interrupted SQL statement execution, resume_token should be copied from the last PartialResultSet yielded before the interruption. Doing this enables the new SQL statement execution to resume where the last one left off. The rest of the request parameters must exactly match the request that yielded this token. seqno (type: String.t, default: nil) - A per-transaction sequence number used to identify this request. This makes each request idempotent such that if the request is received multiple times, at most one will succeed. The sequence number must be monotonically increasing within the transaction. If a request arrives for the first time with an out-of-order sequence number, the transaction may be aborted. Replays of previously handled requests will yield the same response as the first execution. Required for DML statements. Ignored for queries. sql (type: String.t, default: nil) - Required. The SQL string. transaction (type: GoogleApi.Spanner.V1.Model.TransactionSelector.t, default: nil) - The transaction to use. If none is provided, the default is a temporary read-only transaction with strong concurrency. The transaction to use. For queries, if none is provided, the default is a temporary read-only transaction with strong concurrency. Standard DML statements require a ReadWrite transaction. Single-use transactions are not supported (to avoid replay). The caller must either supply an existing transaction ID or begin a new transaction. Partitioned DML requires an existing PartitionedDml transaction ID."},{"ref":"GoogleApi.Spanner.V1.Model.ExecuteSqlRequest.html#decode/2","title":"GoogleApi.Spanner.V1.Model.ExecuteSqlRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.ExecuteSqlRequest.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.ExecuteSqlRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.Expr.html","title":"GoogleApi.Spanner.V1.Model.Expr","type":"module","doc":"Represents an expression text. Example: title: &quot;User account presence&quot; description: &quot;Determines whether the request has a user account&quot; expression: &quot;size(request.user) &gt; 0&quot; Attributes description (type: String.t, default: nil) - An optional description of the expression. This is a longer text which describes the expression, e.g. when hovered over it in a UI. expression (type: String.t, default: nil) - Textual representation of an expression in Common Expression Language syntax. The application context of the containing message determines which well-known feature set of CEL is supported. location (type: String.t, default: nil) - An optional string indicating the location of the expression for error reporting, e.g. a file name and a position in the file. title (type: String.t, default: nil) - An optional title for the expression, i.e. a short string describing its purpose. This can be used e.g. in UIs which allow to enter the expression."},{"ref":"GoogleApi.Spanner.V1.Model.Expr.html#decode/2","title":"GoogleApi.Spanner.V1.Model.Expr.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.Expr.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.Expr.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.Field.html","title":"GoogleApi.Spanner.V1.Model.Field","type":"module","doc":"Message representing a single field of a struct. Attributes name (type: String.t, default: nil) - The name of the field. For reads, this is the column name. For SQL queries, it is the column alias (e.g., &quot;Word&quot; in the query &quot;SELECT &#39;hello&#39; AS Word&quot;), or the column name (e.g., &quot;ColName&quot; in the query &quot;SELECT ColName FROM Table&quot;). Some columns might have an empty name (e.g., !&quot;SELECT UPPER(ColName)&quot;`). Note that a query result can contain multiple fields with the same name. type (type: GoogleApi.Spanner.V1.Model.Type.t, default: nil) - The type of the field."},{"ref":"GoogleApi.Spanner.V1.Model.Field.html#decode/2","title":"GoogleApi.Spanner.V1.Model.Field.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.Field.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.Field.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.GetDatabaseDdlResponse.html","title":"GoogleApi.Spanner.V1.Model.GetDatabaseDdlResponse","type":"module","doc":"The response for GetDatabaseDdl. Attributes statements (type: list(String.t), default: nil) - A list of formatted DDL statements defining the schema of the database specified in the request."},{"ref":"GoogleApi.Spanner.V1.Model.GetDatabaseDdlResponse.html#decode/2","title":"GoogleApi.Spanner.V1.Model.GetDatabaseDdlResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.GetDatabaseDdlResponse.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.GetDatabaseDdlResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.GetIamPolicyRequest.html","title":"GoogleApi.Spanner.V1.Model.GetIamPolicyRequest","type":"module","doc":"Request message for GetIamPolicy method. Attributes"},{"ref":"GoogleApi.Spanner.V1.Model.GetIamPolicyRequest.html#decode/2","title":"GoogleApi.Spanner.V1.Model.GetIamPolicyRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.GetIamPolicyRequest.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.GetIamPolicyRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.Instance.html","title":"GoogleApi.Spanner.V1.Model.Instance","type":"module","doc":"An isolated set of Cloud Spanner resources on which databases can be hosted. Attributes config (type: String.t, default: nil) - Required. The name of the instance&#39;s configuration. Values are of the form projects/&lt;project&gt;/instanceConfigs/&lt;configuration&gt;. See also InstanceConfig and ListInstanceConfigs. displayName (type: String.t, default: nil) - Required. The descriptive name for this instance as it appears in UIs. Must be unique per project and between 4 and 30 characters in length. labels (type: map(), default: nil) - Cloud Labels are a flexible and lightweight mechanism for organizing cloud resources into groups that reflect a customer&#39;s organizational needs and deployment strategies. Cloud Labels can be used to filter collections of resources. They can be used to control how resource metrics are aggregated. And they can be used as arguments to policy management rules (e.g. route, firewall, load balancing, etc.). Label keys must be between 1 and 63 characters long and must conform to the following regular expression: [a-z]([-a-z0-9]*[a-z0-9])?. Label values must be between 0 and 63 characters long and must conform to the regular expression ([a-z]([-a-z0-9]*[a-z0-9])?)?. No more than 64 labels can be associated with a given resource. See https://goo.gl/xmQnxf for more information on and examples of labels. If you plan to use labels in your own code, please note that additional characters may be allowed in the future. And so you are advised to use an internal label representation, such as JSON, which doesn&#39;t rely upon specific characters being disallowed. For example, representing labels as the string: name + &quot;&quot; + value would prove problematic if we were to allow &quot;&quot; in a future release. name (type: String.t, default: nil) - Required. A unique identifier for the instance, which cannot be changed after the instance is created. Values are of the form projects/&lt;project&gt;/instances/a-z*[a-z0-9]. The final segment of the name must be between 2 and 64 characters in length. nodeCount (type: integer(), default: nil) - Required. The number of nodes allocated to this instance. This may be zero in API responses for instances that are not yet in state READY. See the documentation for more information about nodes. state (type: String.t, default: nil) - Output only. The current instance state. For CreateInstance, the state must be either omitted or set to CREATING. For UpdateInstance, the state must be either omitted or set to READY."},{"ref":"GoogleApi.Spanner.V1.Model.Instance.html#decode/2","title":"GoogleApi.Spanner.V1.Model.Instance.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.Instance.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.Instance.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.InstanceConfig.html","title":"GoogleApi.Spanner.V1.Model.InstanceConfig","type":"module","doc":"A possible configuration for a Cloud Spanner instance. Configurations define the geographic placement of nodes and their replication. Attributes displayName (type: String.t, default: nil) - The name of this instance configuration as it appears in UIs. name (type: String.t, default: nil) - A unique identifier for the instance configuration. Values are of the form projects/&lt;project&gt;/instanceConfigs/a-z* replicas (type: list(GoogleApi.Spanner.V1.Model.ReplicaInfo.t), default: nil) - The geographic placement of nodes in this instance configuration and their replication properties."},{"ref":"GoogleApi.Spanner.V1.Model.InstanceConfig.html#decode/2","title":"GoogleApi.Spanner.V1.Model.InstanceConfig.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.InstanceConfig.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.InstanceConfig.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.KeyRange.html","title":"GoogleApi.Spanner.V1.Model.KeyRange","type":"module","doc":"KeyRange represents a range of rows in a table or index. A range has a start key and an end key. These keys can be open or closed, indicating if the range includes rows with that key. Keys are represented by lists, where the ith value in the list corresponds to the ith component of the table or index primary key. Individual values are encoded as described here. For example, consider the following table definition: CREATE TABLE UserEvents ( UserName STRING(MAX), EventDate STRING(10) ) PRIMARY KEY(UserName, EventDate); The following keys name rows in this table: &quot;Bob&quot;, &quot;2014-09-23&quot; Since the UserEvents table&#39;s PRIMARY KEY clause names two columns, each UserEvents key has two elements; the first is the UserName, and the second is the EventDate. Key ranges with multiple components are interpreted lexicographically by component using the table or index key&#39;s declared sort order. For example, the following range returns all events for user &quot;Bob&quot; that occurred in the year 2015: &quot;start_closed&quot;: [&quot;Bob&quot;, &quot;2015-01-01&quot;] &quot;end_closed&quot;: [&quot;Bob&quot;, &quot;2015-12-31&quot;] Start and end keys can omit trailing key components. This affects the inclusion and exclusion of rows that exactly match the provided key components: if the key is closed, then rows that exactly match the provided components are included; if the key is open, then rows that exactly match are not included. For example, the following range includes all events for &quot;Bob&quot; that occurred during and after the year 2000: &quot;start_closed&quot;: [&quot;Bob&quot;, &quot;2000-01-01&quot;] &quot;end_closed&quot;: [&quot;Bob&quot;] The next example retrieves all events for &quot;Bob&quot;: &quot;start_closed&quot;: [&quot;Bob&quot;] &quot;end_closed&quot;: [&quot;Bob&quot;] To retrieve events before the year 2000: &quot;start_closed&quot;: [&quot;Bob&quot;] &quot;end_open&quot;: [&quot;Bob&quot;, &quot;2000-01-01&quot;] The following range includes all rows in the table: &quot;start_closed&quot;: [] &quot;end_closed&quot;: [] This range returns all users whose UserName begins with any character from A to C: &quot;start_closed&quot;: [&quot;A&quot;] &quot;end_open&quot;: [&quot;D&quot;] This range returns all users whose UserName begins with B: &quot;start_closed&quot;: [&quot;B&quot;] &quot;end_open&quot;: [&quot;C&quot;] Key ranges honor column sort order. For example, suppose a table is defined as follows: CREATE TABLE DescendingSortedTable { Key INT64, ... ) PRIMARY KEY(Key DESC); The following range retrieves all rows with key values between 1 and 100 inclusive: &quot;start_closed&quot;: [&quot;100&quot;] &quot;end_closed&quot;: [&quot;1&quot;] Note that 100 is passed as the start, and 1 is passed as the end, because Key is a descending column in the schema. Attributes endClosed (type: list(any()), default: nil) - If the end is closed, then the range includes all rows whose first len(end_closed) key columns exactly match end_closed. endOpen (type: list(any()), default: nil) - If the end is open, then the range excludes rows whose first len(end_open) key columns exactly match end_open. startClosed (type: list(any()), default: nil) - If the start is closed, then the range includes all rows whose first len(start_closed) key columns exactly match start_closed. startOpen (type: list(any()), default: nil) - If the start is open, then the range excludes rows whose first len(start_open) key columns exactly match start_open."},{"ref":"GoogleApi.Spanner.V1.Model.KeyRange.html#decode/2","title":"GoogleApi.Spanner.V1.Model.KeyRange.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.KeyRange.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.KeyRange.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.KeySet.html","title":"GoogleApi.Spanner.V1.Model.KeySet","type":"module","doc":"KeySet defines a collection of Cloud Spanner keys and/or key ranges. All the keys are expected to be in the same table or index. The keys need not be sorted in any particular way. If the same key is specified multiple times in the set (for example if two ranges, two keys, or a key and a range overlap), Cloud Spanner behaves as if the key were only specified once. Attributes all (type: boolean(), default: nil) - For convenience all can be set to true to indicate that this KeySet matches all keys in the table or index. Note that any keys specified in keys or ranges are only yielded once. keys (type: list(list(any())), default: nil) - A list of specific keys. Entries in keys should have exactly as many elements as there are columns in the primary or index key with which this KeySet is used. Individual key values are encoded as described here. ranges (type: list(GoogleApi.Spanner.V1.Model.KeyRange.t), default: nil) - A list of key ranges. See KeyRange for more information about key range specifications."},{"ref":"GoogleApi.Spanner.V1.Model.KeySet.html#decode/2","title":"GoogleApi.Spanner.V1.Model.KeySet.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.KeySet.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.KeySet.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.ListDatabasesResponse.html","title":"GoogleApi.Spanner.V1.Model.ListDatabasesResponse","type":"module","doc":"The response for ListDatabases. Attributes databases (type: list(GoogleApi.Spanner.V1.Model.Database.t), default: nil) - Databases that matched the request. nextPageToken (type: String.t, default: nil) - next_page_token can be sent in a subsequent ListDatabases call to fetch more of the matching databases."},{"ref":"GoogleApi.Spanner.V1.Model.ListDatabasesResponse.html#decode/2","title":"GoogleApi.Spanner.V1.Model.ListDatabasesResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.ListDatabasesResponse.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.ListDatabasesResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.ListInstanceConfigsResponse.html","title":"GoogleApi.Spanner.V1.Model.ListInstanceConfigsResponse","type":"module","doc":"The response for ListInstanceConfigs. Attributes instanceConfigs (type: list(GoogleApi.Spanner.V1.Model.InstanceConfig.t), default: nil) - The list of requested instance configurations. nextPageToken (type: String.t, default: nil) - next_page_token can be sent in a subsequent ListInstanceConfigs call to fetch more of the matching instance configurations."},{"ref":"GoogleApi.Spanner.V1.Model.ListInstanceConfigsResponse.html#decode/2","title":"GoogleApi.Spanner.V1.Model.ListInstanceConfigsResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.ListInstanceConfigsResponse.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.ListInstanceConfigsResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.ListInstancesResponse.html","title":"GoogleApi.Spanner.V1.Model.ListInstancesResponse","type":"module","doc":"The response for ListInstances. Attributes instances (type: list(GoogleApi.Spanner.V1.Model.Instance.t), default: nil) - The list of requested instances. nextPageToken (type: String.t, default: nil) - next_page_token can be sent in a subsequent ListInstances call to fetch more of the matching instances."},{"ref":"GoogleApi.Spanner.V1.Model.ListInstancesResponse.html#decode/2","title":"GoogleApi.Spanner.V1.Model.ListInstancesResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.ListInstancesResponse.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.ListInstancesResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.ListOperationsResponse.html","title":"GoogleApi.Spanner.V1.Model.ListOperationsResponse","type":"module","doc":"The response message for Operations.ListOperations. Attributes nextPageToken (type: String.t, default: nil) - The standard List next-page token. operations (type: list(GoogleApi.Spanner.V1.Model.Operation.t), default: nil) - A list of operations that matches the specified filter in the request."},{"ref":"GoogleApi.Spanner.V1.Model.ListOperationsResponse.html#decode/2","title":"GoogleApi.Spanner.V1.Model.ListOperationsResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.ListOperationsResponse.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.ListOperationsResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.ListSessionsResponse.html","title":"GoogleApi.Spanner.V1.Model.ListSessionsResponse","type":"module","doc":"The response for ListSessions. Attributes nextPageToken (type: String.t, default: nil) - next_page_token can be sent in a subsequent ListSessions call to fetch more of the matching sessions. sessions (type: list(GoogleApi.Spanner.V1.Model.Session.t), default: nil) - The list of requested sessions."},{"ref":"GoogleApi.Spanner.V1.Model.ListSessionsResponse.html#decode/2","title":"GoogleApi.Spanner.V1.Model.ListSessionsResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.ListSessionsResponse.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.ListSessionsResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.Mutation.html","title":"GoogleApi.Spanner.V1.Model.Mutation","type":"module","doc":"A modification to one or more Cloud Spanner rows. Mutations can be applied to a Cloud Spanner database by sending them in a Commit call. Attributes delete (type: GoogleApi.Spanner.V1.Model.Delete.t, default: nil) - Delete rows from a table. Succeeds whether or not the named rows were present. insert (type: GoogleApi.Spanner.V1.Model.Write.t, default: nil) - Insert new rows in a table. If any of the rows already exist, the write or transaction fails with error ALREADY_EXISTS. insertOrUpdate (type: GoogleApi.Spanner.V1.Model.Write.t, default: nil) - Like insert, except that if the row already exists, then its column values are overwritten with the ones provided. Any column values not explicitly written are preserved. replace (type: GoogleApi.Spanner.V1.Model.Write.t, default: nil) - Like insert, except that if the row already exists, it is deleted, and the column values provided are inserted instead. Unlike insert_or_update, this means any values not explicitly written become NULL. update (type: GoogleApi.Spanner.V1.Model.Write.t, default: nil) - Update existing rows in a table. If any of the rows does not already exist, the transaction fails with error NOT_FOUND."},{"ref":"GoogleApi.Spanner.V1.Model.Mutation.html#decode/2","title":"GoogleApi.Spanner.V1.Model.Mutation.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.Mutation.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.Mutation.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.Operation.html","title":"GoogleApi.Spanner.V1.Model.Operation","type":"module","doc":"This resource represents a long-running operation that is the result of a network API call. Attributes done (type: boolean(), default: nil) - If the value is false, it means the operation is still in progress. If true, the operation is completed, and either error or response is available. error (type: GoogleApi.Spanner.V1.Model.Status.t, default: nil) - The error result of the operation in case of failure or cancellation. metadata (type: map(), default: nil) - Service-specific metadata associated with the operation. It typically contains progress information and common metadata such as create time. Some services might not provide such metadata. Any method that returns a long-running operation should document the metadata type, if any. name (type: String.t, default: nil) - The server-assigned name, which is only unique within the same service that originally returns it. If you use the default HTTP mapping, the name should be a resource name ending with operations/{unique_id}. response (type: map(), default: nil) - The normal response of the operation in case of success. If the original method returns no data on success, such as Delete, the response is google.protobuf.Empty. If the original method is standard Get/Create/Update, the response should be the resource. For other methods, the response should have the type XxxResponse, where Xxx is the original method name. For example, if the original method name is TakeSnapshot(), the inferred response type is TakeSnapshotResponse."},{"ref":"GoogleApi.Spanner.V1.Model.Operation.html#decode/2","title":"GoogleApi.Spanner.V1.Model.Operation.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.Operation.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.Operation.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.PartialResultSet.html","title":"GoogleApi.Spanner.V1.Model.PartialResultSet","type":"module","doc":"Partial results from a streaming read or SQL query. Streaming reads and SQL queries better tolerate large result sets, large rows, and large values, but are a little trickier to consume. Attributes chunkedValue (type: boolean(), default: nil) - If true, then the final value in values is chunked, and must be combined with more values from subsequent PartialResultSets to obtain a complete field value. metadata (type: GoogleApi.Spanner.V1.Model.ResultSetMetadata.t, default: nil) - Metadata about the result set, such as row type information. Only present in the first response. resumeToken (type: String.t, default: nil) - Streaming calls might be interrupted for a variety of reasons, such as TCP connection loss. If this occurs, the stream of results can be resumed by re-sending the original request and including resume_token. Note that executing any other transaction in the same session invalidates the token. stats (type: GoogleApi.Spanner.V1.Model.ResultSetStats.t, default: nil) - Query plan and execution statistics for the statement that produced this streaming result set. These can be requested by setting ExecuteSqlRequest.query_mode and are sent only once with the last response in the stream. This field will also be present in the last response for DML statements. values (type: list(any()), default: nil) - A streamed result set consists of a stream of values, which might be split into many PartialResultSet messages to accommodate large rows and/or large values. Every N complete values defines a row, where N is equal to the number of entries in metadata.row_type.fields. Most values are encoded based on type as described here. It is possible that the last value in values is &quot;chunked&quot;, meaning that the rest of the value is sent in subsequent PartialResultSet(s). This is denoted by the chunked_value field. Two or more chunked values can be merged to form a complete value as follows: bool/number/null: cannot be chunked string: concatenate the strings list: concatenate the lists. If the last element in a list is a string, list, or object, merge it with the first element in the next list by applying these rules recursively. object: concatenate the (field name, field value) pairs. If a field name is duplicated, then apply these rules recursively to merge the field values. Some examples of merging: # Strings are concatenated. &quot;foo&quot;, &quot;bar&quot; =&gt; &quot;foobar&quot; # Lists of non-strings are concatenated. [2, 3], [4] =&gt; [2, 3, 4] # Lists are concatenated, but the last and first elements are merged # because they are strings. [&quot;a&quot;, &quot;b&quot;], [&quot;c&quot;, &quot;d&quot;] =&gt; [&quot;a&quot;, &quot;bc&quot;, &quot;d&quot;] # Lists are concatenated, but the last and first elements are merged # because they are lists. Recursively, the last and first elements # of the inner lists are merged because they are strings. [&quot;a&quot;, [&quot;b&quot;, &quot;c&quot;]], [[&quot;d&quot;], &quot;e&quot;] =&gt; [&quot;a&quot;, [&quot;b&quot;, &quot;cd&quot;], &quot;e&quot;] # Non-overlapping object fields are combined. {&quot;a&quot;: &quot;1&quot;}, {&quot;b&quot;: &quot;2&quot;} =&gt; {&quot;a&quot;: &quot;1&quot;, &quot;b&quot;: 2&quot;} # Overlapping object fields are merged. {&quot;a&quot;: &quot;1&quot;}, {&quot;a&quot;: &quot;2&quot;} =&gt; {&quot;a&quot;: &quot;12&quot;} # Examples of merging objects containing lists of strings. {&quot;a&quot;: [&quot;1&quot;]}, {&quot;a&quot;: [&quot;2&quot;]} =&gt; {&quot;a&quot;: [&quot;12&quot;]} For a more complete example, suppose a streaming SQL query is yielding a result set whose rows contain a single string field. The following PartialResultSets might be yielded: { &quot;metadata&quot;: { ... } &quot;values&quot;: [&quot;Hello&quot;, &quot;W&quot;] &quot;chunked_value&quot;: true &quot;resume_token&quot;: &quot;Af65...&quot; } { &quot;values&quot;: [&quot;orl&quot;] &quot;chunked_value&quot;: true &quot;resume_token&quot;: &quot;Bqp2...&quot; } { &quot;values&quot;: [&quot;d&quot;] &quot;resume_token&quot;: &quot;Zx1B...&quot; } This sequence of PartialResultSets encodes two rows, one containing the field value &quot;Hello&quot;, and a second containing the field value &quot;World&quot; = &quot;W&quot; + &quot;orl&quot; + &quot;d&quot;."},{"ref":"GoogleApi.Spanner.V1.Model.PartialResultSet.html#decode/2","title":"GoogleApi.Spanner.V1.Model.PartialResultSet.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.PartialResultSet.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.PartialResultSet.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.Partition.html","title":"GoogleApi.Spanner.V1.Model.Partition","type":"module","doc":"Information returned for each partition returned in a PartitionResponse. Attributes partitionToken (type: String.t, default: nil) - This token can be passed to Read, StreamingRead, ExecuteSql, or ExecuteStreamingSql requests to restrict the results to those identified by this partition token."},{"ref":"GoogleApi.Spanner.V1.Model.Partition.html#decode/2","title":"GoogleApi.Spanner.V1.Model.Partition.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.Partition.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.Partition.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.PartitionOptions.html","title":"GoogleApi.Spanner.V1.Model.PartitionOptions","type":"module","doc":"Options for a PartitionQueryRequest and PartitionReadRequest. Attributes maxPartitions (type: String.t, default: nil) - Note: This hint is currently ignored by PartitionQuery and PartitionRead requests. The desired maximum number of partitions to return. For example, this may be set to the number of workers available. The default for this option is currently 10,000. The maximum value is currently 200,000. This is only a hint. The actual number of partitions returned may be smaller or larger than this maximum count request. partitionSizeBytes (type: String.t, default: nil) - Note: This hint is currently ignored by PartitionQuery and PartitionRead requests. The desired data size for each partition generated. The default for this option is currently 1 GiB. This is only a hint. The actual size of each partition may be smaller or larger than this size request."},{"ref":"GoogleApi.Spanner.V1.Model.PartitionOptions.html#decode/2","title":"GoogleApi.Spanner.V1.Model.PartitionOptions.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.PartitionOptions.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.PartitionOptions.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.PartitionQueryRequest.html","title":"GoogleApi.Spanner.V1.Model.PartitionQueryRequest","type":"module","doc":"The request for PartitionQuery Attributes paramTypes (type: %{optional(String.t) =&gt; GoogleApi.Spanner.V1.Model.Type.t}, default: nil) - It is not always possible for Cloud Spanner to infer the right SQL type from a JSON value. For example, values of type BYTES and values of type STRING both appear in params as JSON strings. In these cases, param_types can be used to specify the exact SQL type for some or all of the SQL query parameters. See the definition of Type for more information about SQL types. params (type: map(), default: nil) - The SQL query string can contain parameter placeholders. A parameter placeholder consists of &#39;@&#39; followed by the parameter name. Parameter names consist of any combination of letters, numbers, and underscores. Parameters can appear anywhere that a literal value is expected. The same parameter name can be used more than once, for example: &quot;WHERE id &gt; @msg_id AND id &lt; @msg_id + 100&quot; It is an error to execute an SQL query with unbound parameters. Parameter values are specified using params, which is a JSON object whose keys are parameter names, and whose values are the corresponding parameter values. partitionOptions (type: GoogleApi.Spanner.V1.Model.PartitionOptions.t, default: nil) - Additional options that affect how many partitions are created. sql (type: String.t, default: nil) - The query request to generate partitions for. The request will fail if the query is not root partitionable. The query plan of a root partitionable query has a single distributed union operator. A distributed union operator conceptually divides one or more tables into multiple splits, remotely evaluates a subquery independently on each split, and then unions all results. This must not contain DML commands, such as INSERT, UPDATE, or DELETE. Use ExecuteStreamingSql with a PartitionedDml transaction for large, partition-friendly DML operations. transaction (type: GoogleApi.Spanner.V1.Model.TransactionSelector.t, default: nil) - Read only snapshot transactions are supported, read/write and single use transactions are not."},{"ref":"GoogleApi.Spanner.V1.Model.PartitionQueryRequest.html#decode/2","title":"GoogleApi.Spanner.V1.Model.PartitionQueryRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.PartitionQueryRequest.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.PartitionQueryRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.PartitionReadRequest.html","title":"GoogleApi.Spanner.V1.Model.PartitionReadRequest","type":"module","doc":"The request for PartitionRead Attributes columns (type: list(String.t), default: nil) - The columns of table to be returned for each row matching this request. index (type: String.t, default: nil) - If non-empty, the name of an index on table. This index is used instead of the table primary key when interpreting key_set and sorting result rows. See key_set for further information. keySet (type: GoogleApi.Spanner.V1.Model.KeySet.t, default: nil) - Required. key_set identifies the rows to be yielded. key_set names the primary keys of the rows in table to be yielded, unless index is present. If index is present, then key_set instead names index keys in index. It is not an error for the key_set to name rows that do not exist in the database. Read yields nothing for nonexistent rows. partitionOptions (type: GoogleApi.Spanner.V1.Model.PartitionOptions.t, default: nil) - Additional options that affect how many partitions are created. table (type: String.t, default: nil) - Required. The name of the table in the database to be read. transaction (type: GoogleApi.Spanner.V1.Model.TransactionSelector.t, default: nil) - Read only snapshot transactions are supported, read/write and single use transactions are not."},{"ref":"GoogleApi.Spanner.V1.Model.PartitionReadRequest.html#decode/2","title":"GoogleApi.Spanner.V1.Model.PartitionReadRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.PartitionReadRequest.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.PartitionReadRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.PartitionResponse.html","title":"GoogleApi.Spanner.V1.Model.PartitionResponse","type":"module","doc":"The response for PartitionQuery or PartitionRead Attributes partitions (type: list(GoogleApi.Spanner.V1.Model.Partition.t), default: nil) - Partitions created by this request. transaction (type: GoogleApi.Spanner.V1.Model.Transaction.t, default: nil) - Transaction created by this request."},{"ref":"GoogleApi.Spanner.V1.Model.PartitionResponse.html#decode/2","title":"GoogleApi.Spanner.V1.Model.PartitionResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.PartitionResponse.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.PartitionResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.PartitionedDml.html","title":"GoogleApi.Spanner.V1.Model.PartitionedDml","type":"module","doc":"Message type to initiate a Partitioned DML transaction. Attributes"},{"ref":"GoogleApi.Spanner.V1.Model.PartitionedDml.html#decode/2","title":"GoogleApi.Spanner.V1.Model.PartitionedDml.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.PartitionedDml.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.PartitionedDml.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.PlanNode.html","title":"GoogleApi.Spanner.V1.Model.PlanNode","type":"module","doc":"Node information for nodes appearing in a QueryPlan.plan_nodes. Attributes childLinks (type: list(GoogleApi.Spanner.V1.Model.ChildLink.t), default: nil) - List of child node indexes and their relationship to this parent. displayName (type: String.t, default: nil) - The display name for the node. executionStats (type: map(), default: nil) - The execution statistics associated with the node, contained in a group of key-value pairs. Only present if the plan was returned as a result of a profile query. For example, number of executions, number of rows/time per execution etc. index (type: integer(), default: nil) - The PlanNode&#39;s index in node list. kind (type: String.t, default: nil) - Used to determine the type of node. May be needed for visualizing different kinds of nodes differently. For example, If the node is a SCALAR node, it will have a condensed representation which can be used to directly embed a description of the node in its parent. metadata (type: map(), default: nil) - Attributes relevant to the node contained in a group of key-value pairs. For example, a Parameter Reference node could have the following information in its metadata: { &quot;parameter_reference&quot;: &quot;param1&quot;, &quot;parameter_type&quot;: &quot;array&quot; } shortRepresentation (type: GoogleApi.Spanner.V1.Model.ShortRepresentation.t, default: nil) - Condensed representation for SCALAR nodes."},{"ref":"GoogleApi.Spanner.V1.Model.PlanNode.html#decode/2","title":"GoogleApi.Spanner.V1.Model.PlanNode.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.PlanNode.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.PlanNode.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.Policy.html","title":"GoogleApi.Spanner.V1.Model.Policy","type":"module","doc":"Defines an Identity and Access Management (IAM) policy. It is used to specify access control policies for Cloud Platform resources. A Policy consists of a list of bindings. A binding binds a list of members to a role, where the members can be user accounts, Google groups, Google domains, and service accounts. A role is a named list of permissions defined by IAM. JSON Example { &quot;bindings&quot;: [ { &quot;role&quot;: &quot;roles/owner&quot;, &quot;members&quot;: [ &quot;user:mike@example.com&quot;, &quot;group:admins@example.com&quot;, &quot;domain:google.com&quot;, &quot;serviceAccount:my-other-app@appspot.gserviceaccount.com&quot; ] }, { &quot;role&quot;: &quot;roles/viewer&quot;, &quot;members&quot;: [&quot;user:sean@example.com&quot;] } ] } YAML Example bindings: - members: - user:mike@example.com - group:admins@example.com - domain:google.com - serviceAccount:my-other-app@appspot.gserviceaccount.com role: roles/owner - members: - user:sean@example.com role: roles/viewer For a description of IAM and its features, see the IAM developer&#39;s guide. Attributes bindings (type: list(GoogleApi.Spanner.V1.Model.Binding.t), default: nil) - Associates a list of members to a role. bindings with no members will result in an error. etag (type: String.t, default: nil) - etag is used for optimistic concurrency control as a way to help prevent simultaneous updates of a policy from overwriting each other. It is strongly suggested that systems make use of the etag in the read-modify-write cycle to perform policy updates in order to avoid race conditions: An etag is returned in the response to getIamPolicy, and systems are expected to put that etag in the request to setIamPolicy to ensure that their change will be applied to the same version of the policy. If no etag is provided in the call to setIamPolicy, then the existing policy is overwritten blindly. version (type: integer(), default: nil) - Deprecated."},{"ref":"GoogleApi.Spanner.V1.Model.Policy.html#decode/2","title":"GoogleApi.Spanner.V1.Model.Policy.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.Policy.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.Policy.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.QueryPlan.html","title":"GoogleApi.Spanner.V1.Model.QueryPlan","type":"module","doc":"Contains an ordered list of nodes appearing in the query plan. Attributes planNodes (type: list(GoogleApi.Spanner.V1.Model.PlanNode.t), default: nil) - The nodes in the query plan. Plan nodes are returned in pre-order starting with the plan root. Each PlanNode&#39;s id corresponds to its index in plan_nodes."},{"ref":"GoogleApi.Spanner.V1.Model.QueryPlan.html#decode/2","title":"GoogleApi.Spanner.V1.Model.QueryPlan.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.QueryPlan.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.QueryPlan.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.ReadOnly.html","title":"GoogleApi.Spanner.V1.Model.ReadOnly","type":"module","doc":"Message type to initiate a read-only transaction. Attributes exactStaleness (type: String.t, default: nil) - Executes all reads at a timestamp that is exact_staleness old. The timestamp is chosen soon after the read is started. Guarantees that all writes that have committed more than the specified number of seconds ago are visible. Because Cloud Spanner chooses the exact timestamp, this mode works even if the client&#39;s local clock is substantially skewed from Cloud Spanner commit timestamps. Useful for reading at nearby replicas without the distributed timestamp negotiation overhead of max_staleness. maxStaleness (type: String.t, default: nil) - Read data at a timestamp &gt;= NOW - max_staleness seconds. Guarantees that all writes that have committed more than the specified number of seconds ago are visible. Because Cloud Spanner chooses the exact timestamp, this mode works even if the client&#39;s local clock is substantially skewed from Cloud Spanner commit timestamps. Useful for reading the freshest data available at a nearby replica, while bounding the possible staleness if the local replica has fallen behind. Note that this option can only be used in single-use transactions. minReadTimestamp (type: DateTime.t, default: nil) - Executes all reads at a timestamp &gt;= min_read_timestamp. This is useful for requesting fresher data than some previous read, or data that is fresh enough to observe the effects of some previously committed transaction whose timestamp is known. Note that this option can only be used in single-use transactions. A timestamp in RFC3339 UTC \\&quot;Zulu\\&quot; format, accurate to nanoseconds. Example: &quot;2014-10-02T15:01:23.045123456Z&quot;. readTimestamp (type: DateTime.t, default: nil) - Executes all reads at the given timestamp. Unlike other modes, reads at a specific timestamp are repeatable; the same read at the same timestamp always returns the same data. If the timestamp is in the future, the read will block until the specified timestamp, modulo the read&#39;s deadline. Useful for large scale consistent reads such as mapreduces, or for coordinating many reads against a consistent snapshot of the data. A timestamp in RFC3339 UTC \\&quot;Zulu\\&quot; format, accurate to nanoseconds. Example: &quot;2014-10-02T15:01:23.045123456Z&quot;. returnReadTimestamp (type: boolean(), default: nil) - If true, the Cloud Spanner-selected read timestamp is included in the Transaction message that describes the transaction. strong (type: boolean(), default: nil) - Read at a timestamp where all previously committed transactions are visible."},{"ref":"GoogleApi.Spanner.V1.Model.ReadOnly.html#decode/2","title":"GoogleApi.Spanner.V1.Model.ReadOnly.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.ReadOnly.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.ReadOnly.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.ReadRequest.html","title":"GoogleApi.Spanner.V1.Model.ReadRequest","type":"module","doc":"The request for Read and StreamingRead. Attributes columns (type: list(String.t), default: nil) - The columns of table to be returned for each row matching this request. index (type: String.t, default: nil) - If non-empty, the name of an index on table. This index is used instead of the table primary key when interpreting key_set and sorting result rows. See key_set for further information. keySet (type: GoogleApi.Spanner.V1.Model.KeySet.t, default: nil) - Required. key_set identifies the rows to be yielded. key_set names the primary keys of the rows in table to be yielded, unless index is present. If index is present, then key_set instead names index keys in index. If the partition_token field is empty, rows are yielded in table primary key order (if index is empty) or index key order (if index is non-empty). If the partition_token field is not empty, rows will be yielded in an unspecified order. It is not an error for the key_set to name rows that do not exist in the database. Read yields nothing for nonexistent rows. limit (type: String.t, default: nil) - If greater than zero, only the first limit rows are yielded. If limit is zero, the default is no limit. A limit cannot be specified if partition_token is set. partitionToken (type: String.t, default: nil) - If present, results will be restricted to the specified partition previously created using PartitionRead(). There must be an exact match for the values of fields common to this message and the PartitionReadRequest message used to create this partition_token. resumeToken (type: String.t, default: nil) - If this request is resuming a previously interrupted read, resume_token should be copied from the last PartialResultSet yielded before the interruption. Doing this enables the new read to resume where the last read left off. The rest of the request parameters must exactly match the request that yielded this token. table (type: String.t, default: nil) - Required. The name of the table in the database to be read. transaction (type: GoogleApi.Spanner.V1.Model.TransactionSelector.t, default: nil) - The transaction to use. If none is provided, the default is a temporary read-only transaction with strong concurrency."},{"ref":"GoogleApi.Spanner.V1.Model.ReadRequest.html#decode/2","title":"GoogleApi.Spanner.V1.Model.ReadRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.ReadRequest.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.ReadRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.ReadWrite.html","title":"GoogleApi.Spanner.V1.Model.ReadWrite","type":"module","doc":"Message type to initiate a read-write transaction. Currently this transaction type has no options. Attributes"},{"ref":"GoogleApi.Spanner.V1.Model.ReadWrite.html#decode/2","title":"GoogleApi.Spanner.V1.Model.ReadWrite.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.ReadWrite.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.ReadWrite.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.ReplicaInfo.html","title":"GoogleApi.Spanner.V1.Model.ReplicaInfo","type":"module","doc":"Attributes defaultLeaderLocation (type: boolean(), default: nil) - If true, this location is designated as the default leader location where leader replicas are placed. See the region types documentation for more details. location (type: String.t, default: nil) - The location of the serving resources, e.g. &quot;us-central1&quot;. type (type: String.t, default: nil) - The type of replica."},{"ref":"GoogleApi.Spanner.V1.Model.ReplicaInfo.html#decode/2","title":"GoogleApi.Spanner.V1.Model.ReplicaInfo.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.ReplicaInfo.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.ReplicaInfo.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.ResultSet.html","title":"GoogleApi.Spanner.V1.Model.ResultSet","type":"module","doc":"Results from Read or ExecuteSql. Attributes metadata (type: GoogleApi.Spanner.V1.Model.ResultSetMetadata.t, default: nil) - Metadata about the result set, such as row type information. rows (type: list(list(any())), default: nil) - Each element in rows is a row whose format is defined by metadata.row_type. The ith element in each row matches the ith field in metadata.row_type. Elements are encoded based on type as described here. stats (type: GoogleApi.Spanner.V1.Model.ResultSetStats.t, default: nil) - Query plan and execution statistics for the SQL statement that produced this result set. These can be requested by setting ExecuteSqlRequest.query_mode. DML statements always produce stats containing the number of rows modified, unless executed using the ExecuteSqlRequest.QueryMode.PLAN ExecuteSqlRequest.query_mode. Other fields may or may not be populated, based on the ExecuteSqlRequest.query_mode."},{"ref":"GoogleApi.Spanner.V1.Model.ResultSet.html#decode/2","title":"GoogleApi.Spanner.V1.Model.ResultSet.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.ResultSet.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.ResultSet.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.ResultSetMetadata.html","title":"GoogleApi.Spanner.V1.Model.ResultSetMetadata","type":"module","doc":"Metadata about a ResultSet or PartialResultSet. Attributes rowType (type: GoogleApi.Spanner.V1.Model.StructType.t, default: nil) - Indicates the field names and types for the rows in the result set. For example, a SQL query like &quot;SELECT UserId, UserName FROM Users&quot; could return a row_type value like: &quot;fields&quot;: [ { &quot;name&quot;: &quot;UserId&quot;, &quot;type&quot;: { &quot;code&quot;: &quot;INT64&quot; } }, { &quot;name&quot;: &quot;UserName&quot;, &quot;type&quot;: { &quot;code&quot;: &quot;STRING&quot; } }, ] transaction (type: GoogleApi.Spanner.V1.Model.Transaction.t, default: nil) - If the read or SQL query began a transaction as a side-effect, the information about the new transaction is yielded here."},{"ref":"GoogleApi.Spanner.V1.Model.ResultSetMetadata.html#decode/2","title":"GoogleApi.Spanner.V1.Model.ResultSetMetadata.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.ResultSetMetadata.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.ResultSetMetadata.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.ResultSetStats.html","title":"GoogleApi.Spanner.V1.Model.ResultSetStats","type":"module","doc":"Additional statistics about a ResultSet or PartialResultSet. Attributes queryPlan (type: GoogleApi.Spanner.V1.Model.QueryPlan.t, default: nil) - QueryPlan for the query associated with this result. queryStats (type: map(), default: nil) - Aggregated statistics from the execution of the query. Only present when the query is profiled. For example, a query could return the statistics as follows: { &quot;rows_returned&quot;: &quot;3&quot;, &quot;elapsed_time&quot;: &quot;1.22 secs&quot;, &quot;cpu_time&quot;: &quot;1.19 secs&quot; } rowCountExact (type: String.t, default: nil) - Standard DML returns an exact count of rows that were modified. rowCountLowerBound (type: String.t, default: nil) - Partitioned DML does not offer exactly-once semantics, so it returns a lower bound of the rows modified."},{"ref":"GoogleApi.Spanner.V1.Model.ResultSetStats.html#decode/2","title":"GoogleApi.Spanner.V1.Model.ResultSetStats.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.ResultSetStats.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.ResultSetStats.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.RollbackRequest.html","title":"GoogleApi.Spanner.V1.Model.RollbackRequest","type":"module","doc":"The request for Rollback. Attributes transactionId (type: String.t, default: nil) - Required. The transaction to roll back."},{"ref":"GoogleApi.Spanner.V1.Model.RollbackRequest.html#decode/2","title":"GoogleApi.Spanner.V1.Model.RollbackRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.RollbackRequest.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.RollbackRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.Session.html","title":"GoogleApi.Spanner.V1.Model.Session","type":"module","doc":"A session in the Cloud Spanner API. Attributes approximateLastUseTime (type: DateTime.t, default: nil) - Output only. The approximate timestamp when the session is last used. It is typically earlier than the actual last use time. createTime (type: DateTime.t, default: nil) - Output only. The timestamp when the session is created. labels (type: map(), default: nil) - The labels for the session. Label keys must be between 1 and 63 characters long and must conform to the following regular expression: [a-z]([-a-z0-9]*[a-z0-9])?. Label values must be between 0 and 63 characters long and must conform to the regular expression ([a-z]([-a-z0-9]*[a-z0-9])?)?. No more than 64 labels can be associated with a given session. See https://goo.gl/xmQnxf for more information on and examples of labels. name (type: String.t, default: nil) - The name of the session. This is always system-assigned; values provided when creating a session are ignored."},{"ref":"GoogleApi.Spanner.V1.Model.Session.html#decode/2","title":"GoogleApi.Spanner.V1.Model.Session.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.Session.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.Session.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.SetIamPolicyRequest.html","title":"GoogleApi.Spanner.V1.Model.SetIamPolicyRequest","type":"module","doc":"Request message for SetIamPolicy method. Attributes policy (type: GoogleApi.Spanner.V1.Model.Policy.t, default: nil) - REQUIRED: The complete policy to be applied to the resource. The size of the policy is limited to a few 10s of KB. An empty policy is a valid policy but certain Cloud Platform services (such as Projects) might reject them."},{"ref":"GoogleApi.Spanner.V1.Model.SetIamPolicyRequest.html#decode/2","title":"GoogleApi.Spanner.V1.Model.SetIamPolicyRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.SetIamPolicyRequest.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.SetIamPolicyRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.ShortRepresentation.html","title":"GoogleApi.Spanner.V1.Model.ShortRepresentation","type":"module","doc":"Condensed representation of a node and its subtree. Only present for SCALAR PlanNode(s). Attributes description (type: String.t, default: nil) - A string representation of the expression subtree rooted at this node. subqueries (type: map(), default: nil) - A mapping of (subquery variable name) -&gt; (subquery node id) for cases where the description string of this node references a SCALAR subquery contained in the expression subtree rooted at this node. The referenced SCALAR subquery may not necessarily be a direct child of this node."},{"ref":"GoogleApi.Spanner.V1.Model.ShortRepresentation.html#decode/2","title":"GoogleApi.Spanner.V1.Model.ShortRepresentation.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.ShortRepresentation.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.ShortRepresentation.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.Statement.html","title":"GoogleApi.Spanner.V1.Model.Statement","type":"module","doc":"A single DML statement. Attributes paramTypes (type: %{optional(String.t) =&gt; GoogleApi.Spanner.V1.Model.Type.t}, default: nil) - It is not always possible for Cloud Spanner to infer the right SQL type from a JSON value. For example, values of type BYTES and values of type STRING both appear in params as JSON strings. In these cases, param_types can be used to specify the exact SQL type for some or all of the SQL statement parameters. See the definition of Type for more information about SQL types. params (type: map(), default: nil) - The DML string can contain parameter placeholders. A parameter placeholder consists of &#39;@&#39; followed by the parameter name. Parameter names consist of any combination of letters, numbers, and underscores. Parameters can appear anywhere that a literal value is expected. The same parameter name can be used more than once, for example: &quot;WHERE id &gt; @msg_id AND id &lt; @msg_id + 100&quot; It is an error to execute an SQL statement with unbound parameters. Parameter values are specified using params, which is a JSON object whose keys are parameter names, and whose values are the corresponding parameter values. sql (type: String.t, default: nil) - Required. The DML string."},{"ref":"GoogleApi.Spanner.V1.Model.Statement.html#decode/2","title":"GoogleApi.Spanner.V1.Model.Statement.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.Statement.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.Statement.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.Status.html","title":"GoogleApi.Spanner.V1.Model.Status","type":"module","doc":"The Status type defines a logical error model that is suitable for different programming environments, including REST APIs and RPC APIs. It is used by gRPC. Each Status message contains three pieces of data: error code, error message, and error details. You can find out more about this error model and how to work with it in the API Design Guide. Attributes code (type: integer(), default: nil) - The status code, which should be an enum value of google.rpc.Code. details (type: list(map()), default: nil) - A list of messages that carry the error details. There is a common set of message types for APIs to use. message (type: String.t, default: nil) - A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the google.rpc.Status.details field, or localized by the client."},{"ref":"GoogleApi.Spanner.V1.Model.Status.html#decode/2","title":"GoogleApi.Spanner.V1.Model.Status.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.Status.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.Status.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.StructType.html","title":"GoogleApi.Spanner.V1.Model.StructType","type":"module","doc":"StructType defines the fields of a STRUCT type. Attributes fields (type: list(GoogleApi.Spanner.V1.Model.Field.t), default: nil) - The list of fields that make up this struct. Order is significant, because values of this struct type are represented as lists, where the order of field values matches the order of fields in the StructType. In turn, the order of fields matches the order of columns in a read request, or the order of fields in the SELECT clause of a query."},{"ref":"GoogleApi.Spanner.V1.Model.StructType.html#decode/2","title":"GoogleApi.Spanner.V1.Model.StructType.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.StructType.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.StructType.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest.html","title":"GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest","type":"module","doc":"Request message for TestIamPermissions method. Attributes permissions (type: list(String.t), default: nil) - REQUIRED: The set of permissions to check for &#39;resource&#39;. Permissions with wildcards (such as &#39;&#39;, &#39;spanner.&#39;, &#39;spanner.instances.*&#39;) are not allowed."},{"ref":"GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest.html#decode/2","title":"GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse.html","title":"GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse","type":"module","doc":"Response message for TestIamPermissions method. Attributes permissions (type: list(String.t), default: nil) - A subset of TestPermissionsRequest.permissions that the caller is allowed."},{"ref":"GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse.html#decode/2","title":"GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.Transaction.html","title":"GoogleApi.Spanner.V1.Model.Transaction","type":"module","doc":"A transaction. Attributes id (type: String.t, default: nil) - id may be used to identify the transaction in subsequent Read, ExecuteSql, Commit, or Rollback calls. Single-use read-only transactions do not have IDs, because single-use transactions do not support multiple requests. readTimestamp (type: DateTime.t, default: nil) - For snapshot read-only transactions, the read timestamp chosen for the transaction. Not returned by default: see TransactionOptions.ReadOnly.return_read_timestamp. A timestamp in RFC3339 UTC \\&quot;Zulu\\&quot; format, accurate to nanoseconds. Example: &quot;2014-10-02T15:01:23.045123456Z&quot;."},{"ref":"GoogleApi.Spanner.V1.Model.Transaction.html#decode/2","title":"GoogleApi.Spanner.V1.Model.Transaction.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.Transaction.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.Transaction.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.TransactionOptions.html","title":"GoogleApi.Spanner.V1.Model.TransactionOptions","type":"module","doc":"Transactions Each session can have at most one active transaction at a time. After the active transaction is completed, the session can immediately be re-used for the next transaction. It is not necessary to create a new session for each transaction. Transaction Modes Cloud Spanner supports three transaction modes: Locking read-write. This type of transaction is the only way to write data into Cloud Spanner. These transactions rely on pessimistic locking and, if necessary, two-phase commit. Locking read-write transactions may abort, requiring the application to retry. Snapshot read-only. This transaction type provides guaranteed consistency across several reads, but does not allow writes. Snapshot read-only transactions can be configured to read at timestamps in the past. Snapshot read-only transactions do not need to be committed. Partitioned DML. This type of transaction is used to execute a single Partitioned DML statement. Partitioned DML partitions the key space and runs the DML statement over each partition in parallel using separate, internal transactions that commit independently. Partitioned DML transactions do not need to be committed. For transactions that only read, snapshot read-only transactions provide simpler semantics and are almost always faster. In particular, read-only transactions do not take locks, so they do not conflict with read-write transactions. As a consequence of not taking locks, they also do not abort, so retry loops are not needed. Transactions may only read/write data in a single database. They may, however, read/write data in different tables within that database. Locking Read-Write Transactions Locking transactions may be used to atomically read-modify-write data anywhere in a database. This type of transaction is externally consistent. Clients should attempt to minimize the amount of time a transaction is active. Faster transactions commit with higher probability and cause less contention. Cloud Spanner attempts to keep read locks active as long as the transaction continues to do reads, and the transaction has not been terminated by Commit or Rollback. Long periods of inactivity at the client may cause Cloud Spanner to release a transaction&#39;s locks and abort it. Conceptually, a read-write transaction consists of zero or more reads or SQL statements followed by Commit. At any time before Commit, the client can send a Rollback request to abort the transaction. Semantics Cloud Spanner can commit the transaction if all read locks it acquired are still valid at commit time, and it is able to acquire write locks for all writes. Cloud Spanner can abort the transaction for any reason. If a commit attempt returns ABORTED, Cloud Spanner guarantees that the transaction has not modified any user data in Cloud Spanner. Unless the transaction commits, Cloud Spanner makes no guarantees about how long the transaction&#39;s locks were held for. It is an error to use Cloud Spanner locks for any sort of mutual exclusion other than between Cloud Spanner transactions themselves. Retrying Aborted Transactions When a transaction aborts, the application can choose to retry the whole transaction again. To maximize the chances of successfully committing the retry, the client should execute the retry in the same session as the original attempt. The original session&#39;s lock priority increases with each consecutive abort, meaning that each attempt has a slightly better chance of success than the previous. Under some circumstances (e.g., many transactions attempting to modify the same row(s)), a transaction can abort many times in a short period before successfully committing. Thus, it is not a good idea to cap the number of retries a transaction can attempt; instead, it is better to limit the total amount of wall time spent retrying. Idle Transactions A transaction is considered idle if it has no outstanding reads or SQL queries and has not started a read or SQL query within the last 10 seconds. Idle transactions can be aborted by Cloud Spanner so that they don&#39;t hold on to locks indefinitely. In that case, the commit will fail with error ABORTED. If this behavior is undesirable, periodically executing a simple SQL query in the transaction (e.g., SELECT 1) prevents the transaction from becoming idle. Snapshot Read-Only Transactions Snapshot read-only transactions provides a simpler method than locking read-write transactions for doing several consistent reads. However, this type of transaction does not support writes. Snapshot transactions do not take locks. Instead, they work by choosing a Cloud Spanner timestamp, then executing all reads at that timestamp. Since they do not acquire locks, they do not block concurrent read-write transactions. Unlike locking read-write transactions, snapshot read-only transactions never abort. They can fail if the chosen read timestamp is garbage collected; however, the default garbage collection policy is generous enough that most applications do not need to worry about this in practice. Snapshot read-only transactions do not need to call Commit or Rollback (and in fact are not permitted to do so). To execute a snapshot transaction, the client specifies a timestamp bound, which tells Cloud Spanner how to choose a read timestamp. The types of timestamp bound are: Strong (the default). Bounded staleness. Exact staleness. If the Cloud Spanner database to be read is geographically distributed, stale read-only transactions can execute more quickly than strong or read-write transaction, because they are able to execute far from the leader replica. Each type of timestamp bound is discussed in detail below. Strong Strong reads are guaranteed to see the effects of all transactions that have committed before the start of the read. Furthermore, all rows yielded by a single read are consistent with each other -- if any part of the read observes a transaction, all parts of the read see the transaction. Strong reads are not repeatable: two consecutive strong read-only transactions might return inconsistent results if there are concurrent writes. If consistency across reads is required, the reads should be executed within a transaction or at an exact read timestamp. See TransactionOptions.ReadOnly.strong. Exact Staleness These timestamp bounds execute reads at a user-specified timestamp. Reads at a timestamp are guaranteed to see a consistent prefix of the global transaction history: they observe modifications done by all transactions with a commit timestamp &lt;= the read timestamp, and observe none of the modifications done by transactions with a larger commit timestamp. They will block until all conflicting transactions that may be assigned commit timestamps &lt;= the read timestamp have finished. The timestamp can either be expressed as an absolute Cloud Spanner commit timestamp or a staleness relative to the current time. These modes do not require a &quot;negotiation phase&quot; to pick a timestamp. As a result, they execute slightly faster than the equivalent boundedly stale concurrency modes. On the other hand, boundedly stale reads usually return fresher results. See TransactionOptions.ReadOnly.read_timestamp and TransactionOptions.ReadOnly.exact_staleness. Bounded Staleness Bounded staleness modes allow Cloud Spanner to pick the read timestamp, subject to a user-provided staleness bound. Cloud Spanner chooses the newest timestamp within the staleness bound that allows execution of the reads at the closest available replica without blocking. All rows yielded are consistent with each other -- if any part of the read observes a transaction, all parts of the read see the transaction. Boundedly stale reads are not repeatable: two stale reads, even if they use the same staleness bound, can execute at different timestamps and thus return inconsistent results. Boundedly stale reads execute in two phases: the first phase negotiates a timestamp among all replicas needed to serve the read. In the second phase, reads are executed at the negotiated timestamp. As a result of the two phase execution, bounded staleness reads are usually a little slower than comparable exact staleness reads. However, they are typically able to return fresher results, and are more likely to execute at the closest replica. Because the timestamp negotiation requires up-front knowledge of which rows will be read, it can only be used with single-use read-only transactions. See TransactionOptions.ReadOnly.max_staleness and TransactionOptions.ReadOnly.min_read_timestamp. Old Read Timestamps and Garbage Collection Cloud Spanner continuously garbage collects deleted and overwritten data in the background to reclaim storage space. This process is known as &quot;version GC&quot;. By default, version GC reclaims versions after they are one hour old. Because of this, Cloud Spanner cannot perform reads at read timestamps more than one hour in the past. This restriction also applies to in-progress reads and/or SQL queries whose timestamp become too old while executing. Reads and SQL queries with too-old read timestamps fail with the error FAILED_PRECONDITION. Partitioned DML Transactions Partitioned DML transactions are used to execute DML statements with a different execution strategy that provides different, and often better, scalability properties for large, table-wide operations than DML in a ReadWrite transaction. Smaller scoped statements, such as an OLTP workload, should prefer using ReadWrite transactions. Partitioned DML partitions the keyspace and runs the DML statement on each partition in separate, internal transactions. These transactions commit automatically when complete, and run independently from one another. To reduce lock contention, this execution strategy only acquires read locks on rows that match the WHERE clause of the statement. Additionally, the smaller per-partition transactions hold locks for less time. That said, Partitioned DML is not a drop-in replacement for standard DML used in ReadWrite transactions. The DML statement must be fully-partitionable. Specifically, the statement must be expressible as the union of many statements which each access only a single row of the table. The statement is not applied atomically to all rows of the table. Rather, the statement is applied atomically to partitions of the table, in independent transactions. Secondary index rows are updated atomically with the base table rows. Partitioned DML does not guarantee exactly-once execution semantics against a partition. The statement will be applied at least once to each partition. It is strongly recommended that the DML statement should be idempotent to avoid unexpected results. For instance, it is potentially dangerous to run a statement such as UPDATE table SET column = column + 1 as it could be run multiple times against some rows. The partitions are committed automatically - there is no support for Commit or Rollback. If the call returns an error, or if the client issuing the ExecuteSql call dies, it is possible that some rows had the statement executed on them successfully. It is also possible that statement was never executed against other rows. Partitioned DML transactions may only contain the execution of a single DML statement via ExecuteSql or ExecuteStreamingSql. If any error is encountered during the execution of the partitioned DML operation (for instance, a UNIQUE INDEX violation, division by zero, or a value that cannot be stored due to schema constraints), then the operation is stopped at that point and an error is returned. It is possible that at this point, some partitions have been committed (or even committed multiple times), and other partitions have not been run at all. Given the above, Partitioned DML is good fit for large, database-wide, operations that are idempotent, such as deleting old rows from a very large table. Attributes partitionedDml (type: GoogleApi.Spanner.V1.Model.PartitionedDml.t, default: nil) - Partitioned DML transaction. Authorization to begin a Partitioned DML transaction requires spanner.databases.beginPartitionedDmlTransaction permission on the session resource. readOnly (type: GoogleApi.Spanner.V1.Model.ReadOnly.t, default: nil) - Transaction will not write. Authorization to begin a read-only transaction requires spanner.databases.beginReadOnlyTransaction permission on the session resource. readWrite (type: GoogleApi.Spanner.V1.Model.ReadWrite.t, default: nil) - Transaction may write. Authorization to begin a read-write transaction requires spanner.databases.beginOrRollbackReadWriteTransaction permission on the session resource."},{"ref":"GoogleApi.Spanner.V1.Model.TransactionOptions.html#decode/2","title":"GoogleApi.Spanner.V1.Model.TransactionOptions.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.TransactionOptions.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.TransactionOptions.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.TransactionSelector.html","title":"GoogleApi.Spanner.V1.Model.TransactionSelector","type":"module","doc":"This message is used to select the transaction in which a Read or ExecuteSql call runs. See TransactionOptions for more information about transactions. Attributes begin (type: GoogleApi.Spanner.V1.Model.TransactionOptions.t, default: nil) - Begin a new transaction and execute this read or SQL query in it. The transaction ID of the new transaction is returned in ResultSetMetadata.transaction, which is a Transaction. id (type: String.t, default: nil) - Execute the read or SQL query in a previously-started transaction. singleUse (type: GoogleApi.Spanner.V1.Model.TransactionOptions.t, default: nil) - Execute the read or SQL query in a temporary transaction. This is the most efficient way to execute a transaction that consists of a single SQL query."},{"ref":"GoogleApi.Spanner.V1.Model.TransactionSelector.html#decode/2","title":"GoogleApi.Spanner.V1.Model.TransactionSelector.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.TransactionSelector.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.TransactionSelector.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.Type.html","title":"GoogleApi.Spanner.V1.Model.Type","type":"module","doc":"Type indicates the type of a Cloud Spanner value, as might be stored in a table cell or returned from an SQL query. Attributes arrayElementType (type: GoogleApi.Spanner.V1.Model.Type.t, default: nil) - If code == ARRAY, then array_element_type is the type of the array elements. code (type: String.t, default: nil) - Required. The TypeCode for this type. structType (type: GoogleApi.Spanner.V1.Model.StructType.t, default: nil) - If code == STRUCT, then struct_type provides type information for the struct&#39;s fields."},{"ref":"GoogleApi.Spanner.V1.Model.Type.html#decode/2","title":"GoogleApi.Spanner.V1.Model.Type.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.Type.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.Type.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlMetadata.html","title":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlMetadata","type":"module","doc":"Metadata type for the operation returned by UpdateDatabaseDdl. Attributes commitTimestamps (type: list(DateTime.t), default: nil) - Reports the commit timestamps of all statements that have succeeded so far, where commit_timestamps[i] is the commit timestamp for the statement statements[i]. database (type: String.t, default: nil) - The database being modified. statements (type: list(String.t), default: nil) - For an update this list contains all the statements. For an individual statement, this list contains only that statement."},{"ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlMetadata.html#decode/2","title":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlMetadata.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlMetadata.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlMetadata.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlRequest.html","title":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlRequest","type":"module","doc":"Enqueues the given DDL statements to be applied, in order but not necessarily all at once, to the database schema at some point (or points) in the future. The server checks that the statements are executable (syntactically valid, name tables that exist, etc.) before enqueueing them, but they may still fail upon later execution (e.g., if a statement from another batch of statements is applied first and it conflicts in some way, or if there is some data-related problem like a NULL value in a column to which NOT NULL would be added). If a statement fails, all subsequent statements in the batch are automatically cancelled. Each batch of statements is assigned a name which can be used with the Operations API to monitor progress. See the operation_id field for more details. Attributes operationId (type: String.t, default: nil) - If empty, the new update request is assigned an automatically-generated operation ID. Otherwise, operation_id is used to construct the name of the resulting Operation. Specifying an explicit operation ID simplifies determining whether the statements were executed in the event that the UpdateDatabaseDdl call is replayed, or the return value is otherwise lost: the database and operation_id fields can be combined to form the name of the resulting longrunning.Operation: &lt;database&gt;/operations/&lt;operation_id&gt;. operation_id should be unique within the database, and must be a valid identifier: a-z*. Note that automatically-generated operation IDs always begin with an underscore. If the named operation already exists, UpdateDatabaseDdl returns ALREADY_EXISTS. statements (type: list(String.t), default: nil) - DDL statements to be applied to the database."},{"ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlRequest.html#decode/2","title":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlRequest.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceMetadata.html","title":"GoogleApi.Spanner.V1.Model.UpdateInstanceMetadata","type":"module","doc":"Metadata type for the operation returned by UpdateInstance. Attributes cancelTime (type: DateTime.t, default: nil) - The time at which this operation was cancelled. If set, this operation is in the process of undoing itself (which is guaranteed to succeed) and cannot be cancelled again. endTime (type: DateTime.t, default: nil) - The time at which this operation failed or was completed successfully. instance (type: GoogleApi.Spanner.V1.Model.Instance.t, default: nil) - The desired end state of the update. startTime (type: DateTime.t, default: nil) - The time at which UpdateInstance request was received."},{"ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceMetadata.html#decode/2","title":"GoogleApi.Spanner.V1.Model.UpdateInstanceMetadata.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceMetadata.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.UpdateInstanceMetadata.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceRequest.html","title":"GoogleApi.Spanner.V1.Model.UpdateInstanceRequest","type":"module","doc":"The request for UpdateInstance. Attributes fieldMask (type: String.t, default: nil) - Required. A mask specifying which fields in [][google.spanner.admin.instance.v1.UpdateInstanceRequest.instance] should be updated. The field mask must always be specified; this prevents any future fields in [][google.spanner.admin.instance.v1.Instance] from being erased accidentally by clients that do not know about them. instance (type: GoogleApi.Spanner.V1.Model.Instance.t, default: nil) - Required. The instance to update, which must always include the instance name. Otherwise, only fields mentioned in [][google.spanner.admin.instance.v1.UpdateInstanceRequest.field_mask] need be included."},{"ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceRequest.html#decode/2","title":"GoogleApi.Spanner.V1.Model.UpdateInstanceRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceRequest.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.UpdateInstanceRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.Spanner.V1.Model.Write.html","title":"GoogleApi.Spanner.V1.Model.Write","type":"module","doc":"Arguments to insert, update, insert_or_update, and replace operations. Attributes columns (type: list(String.t), default: nil) - The names of the columns in table to be written. The list of columns must contain enough columns to allow Cloud Spanner to derive values for all primary key columns in the row(s) to be modified. table (type: String.t, default: nil) - Required. The table whose rows will be written. values (type: list(list(any())), default: nil) - The values to be written. values can contain more than one list of values. If it does, then multiple rows are written, one for each entry in values. Each list in values must have exactly as many entries as there are entries in columns above. Sending multiple lists is equivalent to sending multiple Mutations, each containing one values entry and repeating table and columns. Individual values in each list are encoded as described here."},{"ref":"GoogleApi.Spanner.V1.Model.Write.html#decode/2","title":"GoogleApi.Spanner.V1.Model.Write.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.Spanner.V1.Model.Write.html#t:t/0","title":"GoogleApi.Spanner.V1.Model.Write.t/0","type":"type","doc":""}]